;Copyright (C) 1999 Konstantin Boldyshev <konst@voshod.com>
;Read LICENSE file for full copyright information (GNU GPL)
;
;hackers' echo
;
;0.01: 17-Jun-1999	initial release
;0.02: 04-Jul-1999	small bugfixes
;
;syntax: echo [-n] [string...]
;
;-n	do not add newline
;
;example: echo "hello, world!"


%include "system.inc"

%if KERNEL=20

UDATASEG

n	resb	1

%endif

CODESEG

space	db	0x20
lf	db	0x0A

;ebp	-	argument counter
;edi	-	-n indicator
;2.0 kernels destroy edi after sys_write (why??) so we have to
;keep -n indicator in memory, resulting in additional 15 bytes

START:
%if KERNEL=20
	mov	[n],al
%endif
	pop	ebp
	dec	ebp
	jz	write_lf
	pop	esi

mainloop:
	pop	esi	;pop an argument - message to write
	mov	ecx,esi
	cmp	word [esi],"-n"
	jnz	proceed
%if KERNEL=20
	inc	byte [n]
%elif KERNEL=22
	inc	edi
%endif
	dec	ebp
	jnz	mainloop


exit:
%if KERNEL=20
	cmp	byte [n],0
%elif KERNEL=22
	or	edi,edi
%endif
	jnz	real_exit

write_lf:
	sys_write STDOUT,lf,1

real_exit:
	sys_exit
	
proceed:
	__setreg32	edx,-1	;edx will hold strlen
.strlen:
	inc	edx
	lodsb
	or	al,al
	jnz	.strlen

	sys_write STDOUT
	
	dec	ebp
	jz	exit

	sys_write EMPTY,space,1


	jmp	short mainloop
