;Copyright (C) 1999 Konstantin Boldyshev <konst@voshod.com>
;Read LICENSE file for full copyright information (GNU GPL)
;
; file		: kernel.inc
; created	: 12-apr-1999
; modified	: 04-jul-1999
; version	: 0.03
; assembler	: nasm 0.98
; description	: kernel structures (from kernel includes)
; author	: Konstantin Boldyshev <konst@voshod.com>
; comment	: you need this if you work with kernel structures

%ifndef __KERNEL_INC
%define __KERNEL_INC

%include "config.inc"
%include "types.inc"

%assign	__NEW_UTS_LEN	64
luts		equ	65
struc uname
.sysname	CHAR	luts
.nodename	CHAR	luts
.release	CHAR	luts
.version	CHAR	luts
.machine	CHAR	luts
.domainname	CHAR	luts
endstruc

struc timespec
.tv_sec		U_LONG	1
.tv_nsec	U_LONG	1
endstruc

struc stat
.st_dev		U_SHORT	1
.__pad1		U_SHORT	1
.st_ino		U_LONG	1
.st_mode	U_SHORT	1
.st_nlink	U_SHORT	1
.st_uid		U_SHORT	1
.st_gid		U_SHORT	1
.st_rdev	U_SHORT	1
.__pad2		U_SHORT	1
.st_size	U_LONG	1
.st_blksize	U_LONG	1
.st_blocks	U_LONG	1
.st_atime	U_LONG	1
.__unused1	U_LONG	1
.st_mtime	U_LONG	1
.__unused2	U_LONG	1
.st_ctime	U_LONG	1
.__unused3	U_LONG	1
.__unused4	U_LONG	1
.__unused5	U_LONG	1
endstruc

ld_name		equ	256
struc dirent
.d_ino		U_LONG	1
.d_off		U_LONG	1
.d_reclen	U_SHORT	1
.d_name		CHAR	ld_name
endstruc

struc	mmap_arg_struct
.addr	U_LONG	1
.len	U_LONG	1
.prot	U_LONG	1
.flags	U_LONG	1
.fd	U_LONG	1
.offset	U_LONG	1
endstruc

struc pt_regs
.ebx	U_LONG	1
.ecx	U_LONG	1
.edx	U_LONG	1
.esi	U_LONG	1
.edi	U_LONG	1
.ebp	U_LONG	1
.eax	U_LONG	1
%if KERNEL=20
.ds	U_SHORT	1
.__dsu	U_SHORT	1
.es	U_SHORT	1
.__esu	U_SHORT	1
.fs	U_SHORT	1
.__fsu	U_SHORT	1
.gs	U_SHORT	1
.__gsu	U_SHORT	1
%elif KERNEL=22
.xds	INT	1
.xes	INT	1
%endif
.orig_eax	U_LONG	1
.eip		U_LONG	1
%if KERNEL=20
.cs	U_SHORT	1
.__csu	U_SHORT	1
%elif KERNEL=22
.xcs	INT	1
%endif
.eflags	U_LONG	1
.esp	U_LONG	1
%if KERNEL=20
.ss	U_SHORT	1
.__ssu	U_SHORT	1
%elif KERNEL=22
.xss	INT	1
%endif
endstruc

%endif