;Copyright (C) 1999 Konstantin Boldyshev <konst@voshod.com>
;Read LICENSE file for full copyright information (GNU GPL)
;
;hackers' pwd
;
;0.01: 05-Jun-1999	initial release (KB)
;0.02: 17-Jun-1999	size improvements (KB)
;0.03: 04-Jul-1999	kernel 2.0 version added (YI)
;
;syntax: pwd

%include "system.inc"

UDATASEG

%include "kernel.inc"

%if KERNEL = 20

lBackPath	equ	0x00000040
BackPath	CHAR	lBackPath	;back path buffer
lPath		equ	0x00000100
Path		CHAR	lPath		;path buffer
de		istruc	dirent		;buffer for directory scanning
			.d_ino		U_LONG	1
			.d_off		U_LONG	1
			.d_reclen	U_SHORT	1
			.d_name		CHAR	ld_name
		iend
st		istruc	stat		;buffer for stat inforvation
			.st_dev		U_SHORT	1
			.__pad1		U_SHORT	1
			.st_ino		U_LONG	1
			.st_mode	U_SHORT	1
			.st_nlink	U_SHORT	1
			.st_uid		U_SHORT	1
			.st_gid		U_SHORT	1
			.st_rdev	U_SHORT	1
			.__pad2		U_SHORT	1
			.st_size	U_LONG	1
			.st_blksize	U_LONG	1
			.st_blocks	U_LONG	1
			.st_atime	U_LONG	1
			.__unused1	U_LONG	1
			.st_mtime	U_LONG	1
			.__unused2	U_LONG	1
			.st_ctime	U_LONG	1
			.__unused3	U_LONG	1
			.__unused4	U_LONG	1
			.__unused5	U_LONG	1
		iend
Inode		U_INT	1
Dev		U_SHORT	1
Root.st_dev	U_SHORT	1
Root.st_ino	U_SHORT	1

%elif KERNEL = 22

lBuf	equ	256
Buf	CHAR	lBuf

%endif

CODESEG

%if KERNEL = 20
Root.path	db	'/',NULL
%endif

START:
%if KERNEL = 20
;;getting root's inode and block device
	sys_lstat	Root.path,st		;get stat for root
	mov	ax,[ecx+stat.st_dev]
	mov	[Root.st_dev],ax
	mov	eax,[ecx+stat.st_ino]
	mov	[Root.st_ino],eax
;;data initialization
	mov	ebp,BackPath		;ebp - current position in BackPath
	mov	dword [ebp],'./'	;we are starting from current dir
	mov	edi, Path+lPath-1	;edi - current position in Path - 1
	mov	byte [edi], 0x0A	;NL at the end of Path
	dec	edi
;;the begin of up to root loop
.up:
	sys_lstat	BackPath,st	;get stat for current location
	test	eax,eax
	js	.exit
	mov	byte [edi],'/'
	dec	edi
	mov	ax,[ecx+stat.st_dev]
	cmp	ax,[Root.st_dev]	;is our block device roots'?
	jne	.continue		;no
	mov	eax,[ecx+stat.st_ino]
	cmp	eax,[Root.st_ino]	;is our inode roots'?
	jne	.continue		;no
;;the begin of exit pwd
	inc	edi			;yes, pwd comptete
	mov	esi,Path+lPath-2
	mov	edx,esi
	sub	edx,edi			;is "/" our current dir?
	jz	.print			;yes
	mov	byte [esi],0x0A		;no, remove leading slash
	dec	edx
.print:
	inc	edx
	inc	edx
	sys_write STDOUT,edi		;print work dir
.exit:
	sys_exit0			;and go out
;; the end of exit pwd
.continue:
	mov	dword [ebp],'../'	;move current location up
	lea	ebp, [ebp+3] 
	mov	ax,[ecx+stat.st_dev]
	mov	[Dev], ax		;remember block device for prev location
	mov	eax,[ecx+stat.st_ino]
	mov	[Inode], eax		;remember inode for prev location
	sys_open BackPath,O_RDONLY	;open current location
	test	eax, eax
	js	.exit
	mov	edx,eax
	mov	esi, de			;esi - pointer to dirent
	xor	ecx, ecx		;we start from first dirent
	mov	[esi+dirent.d_off], ecx
;; the begin of get directory entry loop
.next_de:
;;;;;;;;	sys_lseek edx,[esi+dirent.d_off],SEEK_SET
	mov	ebx,edx
	mov	ecx,[esi+dirent.d_off]
	xor	edx,edx
	sys_lseek				;seek to next dirent
	test	eax,eax
	js	.exit
	sys_getdents EMPTY,esi,dirent_size	;get current dirent
	test	eax,eax
	js	.exit
	jz	.exit
	mov	edx,ebx
	;concatenate current location and current dirent name
;;;;	mov	ecx,ebp
;;;;	lea	ebx,[esi+dirent.d_name]
	mov	ebx,ebp
	xor	ecx,ecx
.next.d_name.1
;;;;	mov	al,[ebx]
;;;;	inc	ebx
	mov	al,[esi+ecx+dirent.d_name]
;;;;	mov	[ecx],al
	mov	[ebx+ecx],al
	inc	ecx
	or	al,al
	jnz	.next.d_name.1
	sys_lstat BackPath,st		;get stat for current dirent
	test	eax, eax
	jns	.lstat.ok
	jmp	near .exit
.lstat.ok
	mov	ax,[ecx+stat.st_dev]
	cmp	ax,[Dev]		;is this block device ours'
	jne	.next_de		;no, try next dirent
	mov	eax,[ecx+stat.st_ino]
	cmp	eax,[Inode]		;is this inode ours'
	jne	.next_de		;no, try next dirent
;; the end of get directory entry loop
	sys_close	edx		;close current location
	mov	[ebp],al
	lea	esi,[esi+dirent.d_name]
;;;;	mov	ebx,esi
	xor	ecx,ecx
.next.d_name.2:
;;;;	inc	esi
;;;;	cmp	al,[esi]
	inc	ecx
	cmp	al,[esi+ecx]
	jc	.next.d_name.2
;;;;	mov	ecx,esi
;;;;	sub	ecx,ebx
;;;;	dec	esi
	lea	esi,[esi+ecx-1]
	std
	rep
	movsb
	jmp	near .up
;; the end of up to root loop
%elif KERNEL = 22
	sys_getcwd	Buf,lBuf

	mov	esi,ebx
	xor	edx,edx
.next:
	inc	edx
	lodsb
	or	al,al
	jnz	.next
	mov	byte [esi-1],0x0A
	sub	esi,edx
	sys_write	STDOUT,esi
	sys_exit0
%endif
