;Copyright (C) 1999 Konstantin Boldyshev <konst@voshod.com>
;Read LICENSE file for full copyright information (GNU GPL)
;
;hackers' sleep		[GNU replacement]
;
;0.01: 17-Jun-1999	initial release
;0.02: 03-Jul-1999	sleep is now using sys_nanosleep
;
;syntax: sleep number[nsmhd]...
;
;s	-	seconds
;m	-	minutes
;h	-	hours
;d	-	days
;
;example:	sleep 1 2 3s
;
;TODO: add nanoseconds

%include "system.inc"

UDATASEG

%include "kernel.inc"

t istruc timespec
.tv_sec		U_LONG	1
.tv_nsec	U_LONG	1
iend


CODESEG

;ebp	-	nanoseconds flag

START:
	pop	esi
	pop	esi

.args:
	pop	esi
	or	esi,esi
	jz	.exit
	mov	edi,esi

	__setreg32	eax,0
	__setreg32	ebx,10
	__setreg32	ecx,0
.next:				;convert string to 64 bit integer
	mov	cl,[esi]
	sub	cl,'0'
	jb	.done
	cmp	cl,9
	ja	.done
	mul	ebx
	add	eax,ecx
	adc	edx,0
	inc	esi
	jmp short .next

;some reasonable checks
;can be removed if sure

.done:
	cmp	edi,esi	;some wrong number?
	jz	.exit
	or	edx,edx
	jnz	.ok
	or	eax,eax
	jnz	.ok
.exit:
	sys_exit

.ok:

	__setreg32	ebx,1

	add	cl,'0'
	jz	.set_sleep
.s:
    	cmp	cl,'s'
	jz	.set_sleep2
.m:
	__setreg32	ebx,60
	cmp	cl,'m'
	jz	.set_sleep	
.h:
	__setreg32	ebx,60*60
	cmp	cl,'h'
	jz	.set_sleep	
.d:
	__setreg32	ebx,60*60*24
	cmp	cl,'d'
	jnz	.exit

.set_sleep:
	mul	ebx
.set_sleep2:
	mov	ebx,t
	__setreg32	ecx,NULL

.nanosleep:
;reserved for nanoseconds support
;	mov	dword [ebx],edx
;	mov	dword [ebx+4],eax
;	or	ebp,ebp
;	jnz	.do_sleep
	mov	dword [ebx],eax
	mov	dword [ebx+4],edx
.do_sleep:
	sys_nanosleep
	jmp .args

