;Copyright (C) 1999 Konstantin Boldyshev <konst@voshod.com>
;Read LICENSE file for full copyright information (GNU GPL)
;
;hackers' softdog (software watchdog)
;
;0.01: 04-Jul-1999	initial release
;
;syntax: softdog [PERIOD]
;
;PERIOD (in seconds) - kick period, if missing use default of 10
;
;example:	softdog
;		softdog 15

%include "system.inc"

DEFPERIOD	equ	10	;default period
MAXPERIOD	equ	60	;maximum kernel margin

UDATASEG

%include "kernel.inc"

t istruc timespec
.tv_sec		U_LONG	1
.tv_nsec	U_LONG	1
iend

CODESEG

softdog	db	'/dev/watchdog',NULL

;ebp - period
;
;

START:
	__setreg32 ebp,DEFPERIOD
	pop	esi
	dec	esi
	jz	.start
	pop	esi
	pop	esi
	mov	edi,esi

;convert string to 16 bit integer

%if KERNEL=20
;	__setreg32	eax,0
	__setreg32	ebx,10
	__setreg32	ecx,0
%elif KERNEL=22
	mov	bl,10
%endif

.next:
	mov	cl,[esi]
	sub	cl,'0'
	jb	.done
	cmp	cl,9
	ja	.done
	mul	bl
	add	eax,ecx
	inc	esi
	jmp short .next
.done:
;some reasonable checks
;can be removed if sure
	cmp	edi,esi	;some wrong number?
	jz	.start
	or	eax,eax	;zero?
	jz	.start
	__setreg32 ebx,MAXPERIOD
	cmp	eax,ebx			;if more than max - set max
	jb	.start0
	mov	eax,ebx
.start0:
	mov	ebp,eax
.start:
	mov	[t.tv_sec],ebp

	sys_open ebp,softdog,O_WRONLY
	mov	ebp,eax
	test	eax,eax
	js	.exit

	sys_fork
	or	eax,eax
	jz	.child
.exit:
	sys_exit


.child:
	sys_write ebp,softdog,1
	sys_nanosleep t,NULL
	jmp short .child
