#!/usr/bin/perl
# basename tester, Copyright (C) 1999 Indrek Mandre
# Distributable under the GNU GPL
# Run at your own risk
# NO WARRANTY

use strict;

my $i;
my $j;

my $REALPROGRAM="/bin/basename";
my $TESTPROGRAM="./basename";

my @ARG=("//kala",
          "/tere/kala.kala",
          "",
          "////////////kala/////",
          "kala//////////",
          "/////////kala",
          "//////kala/////////siga.kala",
          "/a/a/a/a/a/a/a/a/a/a/a/a/a/a//a/a/a/a/",
          "oioi",
          "kala",
          "/kala",
          "////////",
          "/" );

my @SUFF=(".kala",
          "",
          "oi",
          "la",
          "/",
          "//////",
          "//a/a/a/a/",
          "/kala" );

# then for zero arguments

    print "Testing for no arguments... ";
    my $s1 = `$REALPROGRAM 2>/dev/null`;
    my $rs1 = $?;
    my $s2 = `$TESTPROGRAM 2>/dev/null`;
    my $rs2 = $?;

    die "Arguments do not generate matched output!\n" unless ($s1 eq $s2);
    die "Return status of arguments does not match!\n" unless ($rs1 == $rs2);
    print "Ok\n";

# at first test only one argument
$| = 1; # we flush

foreach $i (@ARG)
{
  print "Testing argument [$i]... ";
  my $s1 = `$REALPROGRAM "$i"`;
  my $rs1 = $?;
  my $s2 = `$TESTPROGRAM "$i"`;
  my $rs2 = $?;

  die "Argument [$i] does not generate matched output!\n" unless ($s1 eq $s2);
  die "Return status of argument [$i] does not match!\n" unless ($rs1 == $rs2);
  print "Ok\n";
}

# then two arguments

foreach $i (@ARG)
{
  foreach $j (@SUFF)
  {
    print "Testing arguments [$i] [$j]... ";
    my $s1 = `$REALPROGRAM "$i" "$j"`;
    my $rs1 = $?;
    my $s2 = `$TESTPROGRAM "$i" "$j"`;
    my $rs2 = $?;

    die "Arguments [$i][$j] do not generate matched output!\n" unless ($s1 eq $s2);
    die "Return status of arguments [$i][$j] does not match!\n" unless ($rs1 == $rs2);
    print "Ok\n";
  }
}

# then for three or more arguments

    print "Testing for more than two arguments... ";
    my $s1 = `$REALPROGRAM a b c 2>/dev/null`;
    my $rs1 = $?;
    my $s2 = `$TESTPROGRAM a b c 2>/dev/null`;
    my $rs2 = $?;

    die "Arguments do not generate matched output!\n" unless ($s1 eq $s2);
    die "Return status of arguments does not match!\n" unless ($rs1 == $rs2);
    print "Ok\n";

