/*
 * BUTTONS.C extace source file
 * 
 /GDK/GNOME sound (esd) system output display program
 * 
 * Copyright (C) 1999 by Dave J. Andruczyk 
 * 
 * Based upon Code written by The Rasterman and DrMike from redhat.com
 * Re-hacked to look good by The Rasterman (Michael Fullbright)
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include <config.h>
#include <globals.h>
#include <protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#include "logo.xpm"


gint leave(GtkWidget *widget, gpointer *data)
{
    save_config();
    gtk_main_quit();
}

gint button_options(GtkWidget *widget, gpointer *data)
{
    if (GTK_TOGGLE_BUTTON (widget)->active)
    {                                           // button's down
	gtk_widget_show(options);
    }
    else
    {
	gtk_widget_hide(options);
    }
    return 0;
}
gint close_dir_win(GtkWidget *widget, gpointer *data)
{
    if (dir_win_present)
    {
	gtk_widget_hide(dir_win);
	dir_win_present = 0;
    }
    return TRUE;
}

gint close_options(GtkWidget *widget, gpointer *data)
{
    gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(optionsbut), FALSE);
    return TRUE;
}

gint slider_changed(GtkWidget *widget, gpointer *data)
{
    switch ((gint)data)
    {
	case BANDS:
	    bands = GTK_ADJUSTMENT(widget)->value;
	    scalefixed = 0;		// MUST recaluclate scalefactor
	    break;
	case SENSE:
	    sensitivity = GTK_ADJUSTMENT(widget)->value;
	    sensefixed = 0;		// redraw EQ window
	    break;
	case X3D_START:
	    x3d_start = (GTK_ADJUSTMENT(widget)->value)/100;

	    break;
	case X3D_END:
	    x3d_end = (GTK_ADJUSTMENT(widget)->value)/100;

	    break;
	case Y3D_START:
	    y3d_start = (GTK_ADJUSTMENT(widget)->value)/100;

	    break;
	case Y3D_END:
	    y3d_end = (GTK_ADJUSTMENT(widget)->value)/100;

	    break;
	case X3D_SCROLL:
	    x3d_scroll = GTK_ADJUSTMENT(widget)->value;
	    dir_configure(dir_area, NULL);
	    update_pointer();

	    break;
	case Z3D_SCROLL:
	    z3d_scroll = GTK_ADJUSTMENT(widget)->value;
	    dir_configure(dir_area, NULL);
	    update_pointer();

	    break;
	case SPIKE_X_START:
	    xdet_start = (GTK_ADJUSTMENT(widget)->value)/100;
	    break;
	case SPIKE_X_END:
	    xdet_end = (GTK_ADJUSTMENT(widget)->value)/100;
	    break;
	case SPIKE_Y_START:
	    ydet_start = (GTK_ADJUSTMENT(widget)->value)/100;
	    break;
	case SPIKE_Y_END:
	    ydet_end = (GTK_ADJUSTMENT(widget)->value)/100;
	    break;
	case SPIKE_X_SCROLL:
	    xdet_scroll = GTK_ADJUSTMENT(widget)->value;
	    dir_configure(dir_area, NULL);
	    update_pointer();

	    break;
	case SPIKE_Z_SCROLL:
	    zdet_scroll = GTK_ADJUSTMENT(widget)->value;
	    dir_configure(dir_area, NULL);
	    update_pointer();

	    break;
	case DECAY:
	    decay_val = GTK_ADJUSTMENT(widget)->value;
	    break;
	case LAG:
	    lag = GTK_ADJUSTMENT(widget)->value;
	    break;
	default:
	    break;
    }
    return 0;
}

gint button_handle(GtkWidget *widget, gpointer *data)
{
    if (GTK_TOGGLE_BUTTON(widget)->active) // its pressed
    {
	switch((gint)data)
	{
	    case SUPPRESS:

		gtk_label_set(GTK_LABEL(GTK_BIN (widget)->child),
			      "Show Leading Edge");
		show_leader = 0;
		break;
	    case DECAY:
		gtk_label_set(GTK_LABEL(GTK_BIN (widget)->child),
			      "Disable Decay");
		slide = 1;
		break;
	    default:
		break;
	}
    }
    else
    {
	switch((gint)data)
	{
	    case SUPPRESS:
		gtk_label_set(GTK_LABEL(GTK_BIN (widget)->child),
			      "Hide Leading Edge");
		show_leader = 1;
		break;
	    case DECAY:
		gtk_label_set(GTK_LABEL(GTK_BIN (widget)->child),
			      "Enable Decay");
		slide = 0;
		break;
	}

    }
    return 0;
}
	

gint button_3d_fft(GtkWidget *widget, gpointer *data)

{
    if (mode == 4)
	kt_stars_stop(disp);
    gdk_draw_rectangle( pixmap,
			disp->style->black_gc,
			TRUE, 0,0,
			width,height);
    gdk_window_clear(win);
    mode=0;
    if (!dir_win_present)
    {
	gtk_widget_show(dir_win);
	dir_win_present = 1;
    }
	dir_configure(dir_area, NULL);
	update_pointer();


    return 0;
}

gint 
button_2d_fft(GtkWidget *widget, gpointer *data)
{
    if (mode == 4)
	kt_stars_stop(disp);
    gdk_draw_rectangle( pixmap,
			disp->style->black_gc,
			TRUE, 0,0,
			width,height);
    gdk_window_clear(win);
    mode=1;
    if(dir_win_present)
    {
	gtk_widget_hide(dir_win);
	dir_win_present = 0;
    }

    return 0;
}

gint 
button_oscilloscope(GtkWidget *widget, gpointer *data)
{
    if (mode == 4)
	kt_stars_stop(disp);
    gdk_draw_rectangle( pixmap,
			disp->style->black_gc,
			TRUE, 0,0,
			width,height);
    gdk_window_clear(win);
    mode=2;
    if(dir_win_present)
    {
	gtk_widget_hide(dir_win);
	dir_win_present = 0;
    }

    return 0;
}

gint 
button_3d_detailed(GtkWidget *widget, gpointer *data)
{
    if (mode == 4)
	kt_stars_stop(disp);
    gdk_draw_rectangle( pixmap,
			disp->style->black_gc,
			TRUE, 0,0,
			width,height);
    gdk_window_clear(win);
    mode=3;
    if (!dir_win_present)
    {
	gtk_widget_show(dir_win);
	dir_win_present = 1;
    }
	dir_configure(dir_area, NULL);
	update_pointer();

    return 0;
}

gint 
button_about(GtkWidget *widget, gpointer *data)
{
    static GtkWidget *stars = NULL;

    if (mode == 4)
    {
	gtk_object_set_data(GTK_OBJECT(disp), "reset", (gpointer)1);
	kt_stars_stop(disp);
    }
    gdk_draw_rectangle( pixmap,
			disp->style->black_gc,
			TRUE, 0,0,
			width,height);
    gdk_window_clear(win);
    if (!stars)
    {
	GdkPixmap *pm = NULL, *mk = NULL;

	stars = (GtkWidget *)kt_stars_new(disp, pixmap);
	pm = gdk_pixmap_create_from_xpm_d(stars->window, &mk, NULL, logo_xpm);
	kt_stars_set_logo_pixmp(stars, pm, mk);
    }
    mode=4;
    if(dir_win_present)
    {
	gtk_widget_hide(dir_win);
	dir_win_present = 0;
    }
    kt_stars_start(stars, stars->allocation.width, stars->allocation.height);
    return 0;
}

