/*
 * EVENTS.C extace source file
 * 
 /GDK/GNOME sound (esd) system output display program
 * 
 * Copyright (C) 1999 by Dave J. Andruczyk 
 * 
 * Based upon Code written by The Rasterman and DrMike from redhat.com
 * Re-hacked to look good by The Rasterman (Michael Fullbright)
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */

#include <config.h>
#include <globals.h>
#include <protos.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#include <esd.h>

gint button_notify_event (GtkWidget *widget, GdkEventButton *event)
{
    int x,y;
    int result;
    x = event->x;
    y = event->y;
    result = test_if_close(x,y);
    if(event->state & (GDK_MOD1_MASK + GDK_BUTTON1_MASK))
    {
	    pt_lock = 0;
	    one_to_fix = 0;
#ifdef DEBUG
	    g_print("BUTTON RELEASED!! releasing lock\n");
#endif
	    return TRUE;
    }
    if (event->button == 1 ) // BUTTON NUMBER!!!
    {
	if (result > 0)
	{
#ifdef DEBUG
	    g_print("mouse is close enough to an endpoint\n");
	    g_print("setting lock\n");
#endif
	    pt_lock = 1;
	    one_to_fix = result;
	}
	else 
	{
#ifdef DEBUG
	    g_print("mouse is NOT close enough to an endpoint\n");
	    g_print("releasing lock\n");
#endif
	    pt_lock = 0;
	    one_to_fix = 0;
	}
    }


    return TRUE;
}
gint motion_notify_event (GtkWidget *widget, GdkEventMotion *event)
{
    int x, y;
    GdkModifierType state;

    if (event->is_hint)
    {
	gdk_window_get_pointer (event->window, &x, &y, &state);
    }
    else
    {
	x = event->x;
	y = event->y;
	state = event->state;
    }

    if (pt_lock)
    {
	switch (one_to_fix)
	{
	    case CHANGE_X_START:
		change_x_start(x,y);
		break;
	    case CHANGE_X_END:
		change_x_end(x,y);
		break;
	    default:
		break;
	}
    }
    return TRUE;
}

int test_if_close(int x_fed, int y_fed)
{
    gint x_error;
    gint y_error;
    gint junk;
    struct point 
    {
	gint x;
	gint y;
    }start,end;
    gint x_rel;
    gint y_rel;

    // Must pass both X and Y tests to be "captured", if both points pass
    // then we're in trouble... :(

    switch (mode)
    {
	case 0:
	    {
		start.x = (x3d_start*x_draw_width);
		start.y = ((1.0-y3d_start)*y_draw_height);
		end.x = (x3d_end*x_draw_width);
		end.y = ((1.0-y3d_end)*y_draw_height);
		x_rel = x_fed - x_border - abs(x3d_scroll); 
		if (x3d_scroll < 0)
		    x_rel -= x3d_scroll;
		y_rel = y_fed - 3*y_border - (abs(z3d_scroll)/2);

		// tests to see if the mouse pointer is close to an end of an

		if (abs((start.x-x_rel)) < 20)
		{
		    if (abs((start.y-y_rel)) < (20 + abs(z3d_scroll/2)))
		    {
			return (CHANGE_X_START);
		    }
		}
		else if (abs((end.x-x_rel)) < 20)
		{
		    if (abs((end.y-y_rel)) < 20 + levels[0])
		    {
			return (CHANGE_X_END);
		    }
		}

		break;
	    }
	case 3:
	    {
		start.x = (xdet_start*x_draw_width);
		start.y = ((1.0-ydet_start)*y_draw_height);
		end.x = xdet_end*x_draw_width;
		end.y = (1.0-ydet_end)*y_draw_height;
		x_rel = x_rel - x_border - xdet_scroll/2; 
		if (xdet_scroll < 0)
		    x_rel += xdet_scroll;
		y_rel = y_fed-3*y_border - abs((zdet_scroll/2));

		// tests to see if the mouse pointer is close to an end of an
		 
		if (abs((start.x-x_rel)) < 20)
		{
		    g_print("");
#ifdef DEBUG
		    g_print("Start found\n");
#endif
		    if (abs((start.y-y_rel)) < 20)
		    {
			return (CHANGE_X_START);
		    }
		}
		else if (abs((end.x-x_rel)) < 20)
		{
#ifdef DEBUG
		    g_print("End found\n");
#endif
		    if (abs((end.y-y_rel)) < 20)
		    {
			return (CHANGE_X_END);
		    }
		}
		break;
	    }
    }

    return -1;
}

int change_x_start(gint x_rel, gint y_rel)
{
    y_rel -= 3.5*y_border;
    switch (mode)
    {
	case 0:
	    x_rel -= x_border + x3d_scroll/2;
	    break;
	case 3:
	    x_rel -= x_border;
	    break;
    }

    if (x_rel > x_draw_width)
	x_rel = x_draw_width;
    if (x_rel < x_offset/2)
	x_rel = x_offset/2;
    if (y_rel > y_draw_height)
	y_rel = y_draw_height;
    if (y_rel < y_offset/2)
	y_rel = y_offset/2;
    switch (mode)
    {
	case 0:
	    {
		x3d_start = abs(abs(0.5*x3d_scroll)-(gfloat)x_rel)/(gfloat)x_draw_width;
		y3d_start = 1.0-(abs(abs(0.5*z3d_scroll)-(gfloat)y_rel)/(gfloat)y_draw_height);
		GTK_ADJUSTMENT (x3d_start_ptr)->value = x3d_start*100;
		GTK_ADJUSTMENT (y3d_start_ptr)->value = y3d_start*100;
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (x3d_start_ptr));
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (y3d_start_ptr));
		break;
	    }
	case 3:
	    {
		xdet_start = abs(abs(0.5*xdet_scroll)-(gfloat)x_rel)/(gfloat)x_draw_width;
		ydet_start = 1.0-(abs(abs(0.5*zdet_scroll)-(gfloat)y_rel)/(gfloat)y_draw_height);
		GTK_ADJUSTMENT (xdet_start_ptr)->value = xdet_start*100;
		GTK_ADJUSTMENT (ydet_start_ptr)->value = ydet_start*100;
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (xdet_start_ptr));
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (ydet_start_ptr));
		break;
	    }
    }
}

int change_x_end(gint x_rel, gint y_rel)
{
    y_rel -= 3.5*y_border;
    switch (mode)
    {
	case 0:
	    x_rel -= x_border + x3d_scroll/2;
	    break;
	case 3:
	    x_rel -= x_border;
	    break;
    }

    if (x_rel > x_draw_width)
	x_rel = x_draw_width;
    if (x_rel < x_offset/2)
	x_rel = x_offset/2;
    if (y_rel > y_draw_height)
	y_rel = y_draw_height;
    if (y_rel < y_offset/2)
	y_rel = y_offset/2;
    switch (mode)
    {
	case 0:
	    {
		x3d_end = abs(abs(0.5*x3d_scroll)-(gfloat)x_rel)/(gfloat)x_draw_width;
		y3d_end = 1.0-(abs(abs(0.5*z3d_scroll)-(gfloat)y_rel)/(gfloat)y_draw_height);
		GTK_ADJUSTMENT (x3d_end_ptr)->value = x3d_end*100;
		GTK_ADJUSTMENT (y3d_end_ptr)->value = y3d_end*100;
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (x3d_end_ptr));
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (y3d_end_ptr));
		break;
	    }
	case 3:
	    {
		xdet_end = abs(abs(0.5*xdet_scroll)-(gfloat)x_rel)/(gfloat)x_draw_width;
		ydet_end = 1.0-(abs(abs(0.5*zdet_scroll)-(gfloat)y_rel)/(gfloat)y_draw_height);
		GTK_ADJUSTMENT (xdet_end_ptr)->value = xdet_end*100;
		GTK_ADJUSTMENT (ydet_end_ptr)->value = ydet_end*100;
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (xdet_end_ptr));
		gtk_adjustment_value_changed(GTK_ADJUSTMENT (ydet_end_ptr));
		break;
	    }
    }

}
