/*
 /GDK/GNOME sound (esd) system output display program
 * 
 * Copyright (C) 1999 by Dave J. Andruczyk 
 * 
 * Based upon Code written by The Rasterman and DrMike from redhat.com
 * 
 * This software comes under the GPL (GNU Public License)
 * You may freely copy,distribute etc. this as long as the source code
 * is made available for FREE.
 * 
 * No warranty is made or implied. You use this program at your own risk.
 */
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>

/* NSAMP is number of samples per FFT */
/* RATE  is sample rate (samples/sec) */
//#define NSAMP  512 // for a REALLY FAST display
//#define NSAMP  1024  // for a normal display speed
#define NSAMP  2048  // fftw experimental 
//#define NSAMP  4096  // fftw experimental 
#define BUFS   8
#define RATE   44100

#define MAXBANDS 128		// maximum number of bands
#define SUPPRESS	0x1
#define DECAY		0x2
#define BANDS		0x4
#define X3D_START	0x8
#define Y3D_START	0x10
#define X3D_SCROLL	0x20
#define Z3D_SCROLL	0x40
#define SPIKE_X_START	0x80
#define SPIKE_Y_START	0x100
#define SPIKE_X_SCROLL	0x200
#define SPIKE_Z_SCROLL	0x400
#define SENSE		0x800
#define LAG		0x1000
#define Y3D_END		0x2000
#define X3D_END		0x4000
#define SPIKE_X_END	0x8000
#define SPIKE_Y_END	0x10000
#define SPIKE		0x20000
#define THREE_D		0x40000
#define START		0x80000
#define END		0x100000

#define CHANGE_X_START	0x200000
#define CHANGE_X_END	0x400000


gint 	       bands;	// to start with, should be configurable
GtkWidget     *disp;
GtkWidget     *optionsbut;
GtkWidget     *dir_win;
GtkWidget     *dir_area;	// directional window area
GdkPixmap     *dir_pixmap;	// directional window pixmap
GdkWindow     *win;
GdkGC         *gc;
GdkGC 	      *arc_gc;
GdkPixmap     *pixmap;
GtkWidget     *options;
gint           width;
gint           height;
gint           colortab[MAXBANDS][64];// ugly, statically allocated to up to MAXBANDS bands
gint           mode;
GdkImlibImage *im;
GdkPixmap     *grad[256];

short          aubuf[BUFS][NSAMP];
double        *datawindow;
double         datawindowsum;
double         audata[NSAMP]; // (x2 ?? )
double         auout[NSAMP];
double         audata_backup[NSAMP];
double         aufft[NSAMP];
guint          auval[NSAMP];
gint           sound;
gint           curbuf;
gint           lag;

// New stuff (configurables)

gint seg_height;	// height per segment in 2d spectrum analyzer
gint seg_space;		// space between segments in 2d analyzer
gint slide;		// slide and decay are tied together
gint decay_val;	// decay_val ONLY works with slide "on" (1)
gint xdet_scroll;	// detailed scroll in pixels
gint zdet_scroll;	// detailed scroll in pixels
gfloat xdet_start;	// The 3d DETAILED fft's amount of horizontal
gfloat ydet_start;	// detailed y axis start position (percent)
gfloat x3d_start;	// The 3d X start point of axis (percentage)
gfloat y3d_start;	// The 3d Y start point of axis (percentage)
gfloat xdet_end;	// The 3d DETAILED fft's amount of horizontal
gfloat ydet_end;	// detailed y axis start position (percent)
gfloat x3d_end;		// 3D fft X end point of axis (percentage)
gfloat y3d_end;		// 3D fft Y end point of axis (percentage)
gint x3d_scroll;	// 3D scroll in pixels x axis
gint z3d_scroll;	// 3D scroll in pixels z axis
gint det_size;		// detailed size of each pip

gint x_draw_width;	// 3D drawing area space after calculations
gint y_draw_height;	// 3D drawing area space after calculations

gint x_border;		// border on right side of display
gint x_offset;		// 3D X axis offset for centering
gint x_shift;		// 3D shift factor(x axis)depending on axis tilt
gint x_shift_per_block;	// shift in pixels per block for 3D mode

gint y_border;		// border on right side of display
gint y_offset;		// 3D X axis offset for centering
gint y_shift;		// 3D shift factor(x axis)depending on axis tilt
gint y_shift_per_block;	// shift in pixels per block for 3D mode
float scale;
gint  scalefixed;	// its NOT fixed YET. (done dynamically)
gint  sensefixed;	// its NOT fixed YET. (done dynamically)
float scalefactor; 	// dynamically figured out by the program
gint show_leader;	// show leading edge on 3d landscape fft
			// space used. (just run it to see.... :)
gint sensitivity;	// Brightness sensitivity, so the colortable
			// WON'T max out when you resize
gfloat ydet_special;
gint x_fudge;		// fudge factor
gint y_fudge;		// fudge factor
gint top;		// Top of window
gint bottom;		// Bottom or window
gint lo_width;		// Local width. (window inside of window)
gint maxlevel;		// maximum level reached on Graphic Eq mode
gint prevlevel;		// maximum level reached on Graphic Eq mode
gint bar_start;		// start position for bars on graphic EQ
gfloat pix_per_block;	// pixels per block
gint pix_int;		// int version of above
gint space_used;	// space the display takes up
gint extras;
gint to_get; 
gint pos;
gint last_is_full; // its initially ready ??
gfloat x_disp; // X displacement
gfloat y_disp; // Y displacement
gfloat old_x_disp; // X displacement
gfloat old_y_disp; // Y displacement
gint dir_win_present;

// Test for slider updates
GtkObject *x3d_start_ptr;
GtkObject *x3d_end_ptr;
GtkObject *y3d_start_ptr;
GtkObject *y3d_end_ptr;
GtkObject *xdet_start_ptr;
GtkObject *xdet_end_ptr;
GtkObject *ydet_start_ptr;
GtkObject *ydet_end_ptr;
GtkObject *x3d_scroll_ptr;
GtkObject *z3d_scroll_ptr;
GtkObject *xdet_scroll_ptr;
GtkObject *zdet_scroll_ptr;
GtkWidget *main_win_ptr;
GtkWidget *dir_win_ptr;
GtkWidget *control_win_ptr;

double levels[MAXBANDS];
gint pt_lock;
gint one_to_fix;


