/*
 * This file is part of F-CULT.
 * 
 * Copyright (C) 1999 Lauri Hstholm.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * To contact Lauri Hstholm, send e-mail to laurijh@iname.com
 */

#include "main.h"


#define SLDID "|139624|"
#define SLXID "{F-MAIN"
#define DDDID "[Header]"

#define SLDCOMMENTS "\
*****************************************************\n\
* This file was created by F-CULT " VERSION "             *\n\
* The contents of this file should never be altered *\n\
* manually!!                                        *\n\
*  FORMAT :                                         *\n\
*    Lines begining with | are option strings       *\n\
*    Lines begining with * are comments             *\n\
*    Lines begining with > are Notes                *\n\
*    Lines begining with + are Directories          *\n\
*    Lines begining with . are Files                *\n\
*****************************************************\n\
\n"
#define SLDFIELD0 "139624"	/* Don't change! (SLD identifier) */
#define SLDFIELD1 "1"		/* ditto (version) */
#define SLDFIELD2 "1"		/* ditto (unknown (minor version?)) */
/* field #3 is the date, created by appendheader() */
#define SLDFIELD4 "TRUE"	/* files inside dirs sorted? */
/* #6 is number of dir entries, created by appendheader(). */


#define SLXCOMMENTS "\
***********************************\n\
* Listing created by F-CULT " VERSION " *\n\
***********************************\n\
\n"
#define SLXFIELD0 "{F-MAIN\n\n"
#define SLXFIELD1 "[SETTINGS\n"
#define SLXFIELD2 "^CURRENT_VERSION=200.001\n"
#define SLXFIELD3 "^FUNCTIONAL_VERSION=200.001\n"
#define SLXFIELD4 "^COMPATBILITY_VERSION=200.001\n"	/* not my typo :) */
#define SLXFIELD5 "\"VERSION_NOTE=Version "
#define SLXFIELD6 "\n#FILE_TOKENS=3\n"
#define SLXFIELD7 "#DIRECTORY_TOKENS=1\n"
#define SLXFIELD8 "`PARSE_CHAR=|\n"
#define SLXFIELD9 "#UPDATED=" /* seconds since Epoch (or not..see README) */
#define SLXFIELD10 "#FILES="
#define SLXFIELD11 "#DIRS="
#define SLXFIELD12 "]\n\n"
#define SLXFIELD13 "[NOTES\n"
#define SLXFIELD14 "]\n\n"
#define SLXFIELD15 "[LIST\n"
#define SLXFOOTER "]\n\n}\n"


#define DDDCOMMENTS "\
; This list was generated using F-CULT\n\
; Do not modify any parts of this list by hand!\n\
\n"
#define DDDFIELD0 "[Header]\n"
#define DDDFIELD1 "Version=2.1.005\n"	/* better leave this as it is */
#define DDDFIELD2 "Creation Date="
#define DDDFIELD3 "Creation Time="
#define DDDFIELD4 "Directories="
#define DDDFIELD5 "Files="
#define DDDFOOTER "\n[End mark]\n"


int gettype(FILE *infile);
int parselist(FILE *infile, short listnum);

char *cleandirname(char *dirname);

struct stack_unit
{
	char *data;
	struct stack_unit *next;
}*top;


int read_dir(char *dirname, short listnum);
int read_file(char *filename, short listnum);

void append_dir(FILE *outfile, char *dirname);
void append_file(FILE *outfile, char *filename, long unsigned filesize, long filetime);
void appendfooter(FILE *outfile);
void appendheader(FILE *outfile);
void outputlist(FILE *outfile);

/* These funcs are modified versions of the stack code in Marshall
 * Brain's "Introduction to C Programming" tutorial (thanks): */
void stack_push(char *dirtopush);
void stack_pop(char *dirname);
