/*
** Copyright (C) 6 July 1999 George Saj <gsaj@acm.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include <gtk/gtk.h>
#include "psinfo.h"


void close_dialog(GtkWidget *widget, gpointer data){

     gtk_widget_destroy (GTK_WIDGET (data));
}

void remove_grab(GtkWidget *widget, gpointer data){
     gtk_grab_remove(GTK_WIDGET(widget));
}

/* keep in mind this dialog creator doesn't show the dialog on its own */
GtkWidget *create_simple_dialog(gchar *title) {
     GtkWidget *dialog;
     dialog = gtk_dialog_new();
     gtk_signal_connect(GTK_OBJECT (dialog), "destroy",
			GTK_SIGNAL_FUNC(remove_grab), &dialog);
     gtk_window_set_title (GTK_WINDOW(dialog), title);
     return dialog;
     
}
void display_about_dialog(GtkWidget *w, gpointer data){
    
     GtkWidget *about_dialog, *label1, *label2, *button;

     about_dialog = create_simple_dialog("About");
     gtk_container_border_width (GTK_CONTAINER (about_dialog), 5);

     label1 = gtk_label_new(GTASKMAN_VERSION);
     label2 = gtk_label_new(AUTHOR_TEXT);

     gtk_box_pack_start(GTK_BOX(GTK_DIALOG (about_dialog)->vbox),
			label1, TRUE, TRUE, 0);
     gtk_box_pack_start(GTK_BOX(GTK_DIALOG (about_dialog)->vbox),
			label2, TRUE, TRUE, 0);
     gtk_widget_show(label1);
     gtk_widget_show(label2);
     
     button = gtk_button_new_with_label("OK");
     gtk_signal_connect (GTK_OBJECT(button),"clicked",
			 GTK_SIGNAL_FUNC(close_dialog),
			 about_dialog);
     GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
     
     gtk_box_pack_start (GTK_BOX (GTK_DIALOG (about_dialog)->action_area),
			 button, TRUE,TRUE,0);
     gtk_widget_grab_default(button);
     gtk_widget_show(button);
     gtk_widget_show(about_dialog);
     gtk_grab_add(about_dialog);

}

void proc_scan(GtkWidget *w, gpointer data){
  RESCAN();
}

void save_yn_dialog(GtkWidget *w, gpointer data){

}

void column_filter(GtkWidget *widget, gpointer data){
     /* Here there will be a dialog where you can pick the columns you like */
     
}
void userfilter(GtkWidget *w, gpointer data){
     /* Here I'll chop up the first column of data from the clist, 
creating a list of users. then I'll probably just to stick it in a 
dialog and make a pull down list.
      */     
}

/* For the menu */
static GtkItemFactoryEntry menu_items[] = {
  {"/_File",         NULL,         NULL, 0, "<Branch>"},
  {"/File/_Rescan",    "<control>R", proc_scan, 0, NULL},
  {"/File/Save options",     "<control>S", 0, 0, NULL},
  {"/File/sep1",     NULL,         NULL, 0, "<Separator>"},
  {"/File/Quit",     "<control>Q", gtk_main_quit, 0, NULL},
  {"/Fi_lter",      NULL,         NULL, 0, "<Branch>"},
  {"/Filter/By User...",  NULL,         userfilter, 0, NULL},
  {"/Filter/Show All", "<control>A",    0, 0, NULL},
  {"/Filter/Columns...",         NULL,  NULL, 0, NULL},
  {"/_Help",         NULL,         NULL, 0, "<LastBranch>"},
  {"/_Help/About",   NULL,         display_about_dialog, 0, NULL},
};

GtkWidget *get_main_menu(GtkWidget *window) {
  int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
  GtkWidget *menubar;
  GtkItemFactory *item_factory;
  GtkAccelGroup *accel_group;
  accel_group = gtk_accel_group_new();
  item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>",
				      accel_group);
  
  gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);
  gtk_accel_group_attach (accel_group, GTK_OBJECT (window));
  
  menubar = gtk_item_factory_get_widget(item_factory, "<main>");
  gtk_widget_show(menubar);
  return menubar;
}














