#!/usr/bin/perl
#
# hwinfo version 0.1
# 
# Author        : Robert Current (rob@current.nu)
#
# Originally  based on something called "watch.cgi"
# By            : stimpson (rufus365@mindspring.com)
#
# Description   : a cool little perl script that will try to gather 
#                 information about your systems hardware.
#                 
# Use           : This was originally written for use with hwinfo2html
#                 but may have other uses as well.
#
# History       : 2/22/98 Initial public release version 0.1 of watch.cgi
# History       : 7/11/99 Initial public release version 0.1 of hwinfo
#
# Intended Layout and consept:
#                   For "correct" use by applications which will call 
#                   this script, it is hoped that it will be named 
#                   hwinfo-________ where the blank is filled in by 
#                   the result of running the "uname -sr" command.
#                   So, on my system I get:
#                 $  bash-2.03$ uname -sr
#                 $  FreeBSD 3.2-STABLE
#                   and the application should therefore be called:
#                   "hwinfo-FreeBSD-3.2-stable"
#                   By following this logic, it will be possable to 
#                   write versions of this script for many diffrent 
#                   UNIX OS's, and when a parent application want's to
#                   call this applicaition, it will be able to know
#                   the correct version to call, based on the result of
#                   "uname -sr"
#
#              It is very likely that although the output on each system
#              should be as similar as possable, the way in which to get
#              that information will vary substantually.  Therefore, the
#              layout of the output of calling this command is outlined
#              below.  Rewrite the application as nessary to obtain this
#              information, BUT DON'T FORGET TO RENAME IT AS DESCRIBED
#              ABOVE!
#
#----------EXAMPLE #1---A Home PC with IDE and SCSI--------
#
# CPU(s): One AMD-K6(tm) 3D processor
# Clock Speed: 301MHz
# Physical RAM: 128MB
# Swap RAM: 102MB
# Storage Device 0 Type: IDE
# Storage Device 0 Model: IBM-DTTA-350640
# Storage Device 0 Capacity: 8063MB w/467kB Cache
# Storage Device 1 Type: IDE
# Storage Device 1 Model: MICROPOLIS 4540A
# Storage Device 1 Capacity: 3815MB w/228kB Cache
# Storage Device 2 Type: IDE
# Storage Device 2 Model: SAMSUNG PLS-31274A
# Storage Device 2 Capacity: 1214MB w/256kB Cache
# Storage Device 3 Type: IDE
# Storage Device 3 Model: ATAPI 4X CD-ROM drive
# Storage Device 3 Capacity: 128kB Cache
# Storage Device 4 Type: FAST-20 WIDE SCSI
# Storage Device 4 Model: MICROPOLIS 4345WS
# Storage Device 4 Capacity: 4340MB
# Storage Device 5 Type: FAST-10 SCSI
# Storage Device 5 Model: PLEXTOR CD-R   PX-W4220T
# Storage Device 5 Capacity: 128kB Cache
# Video System: Matrox Millennium (rev 1)
# Video RAM: 4M
# 
#--------------------------------
#
#
#----------EXAMPLE #2---An old SGI Peronal IRIS---------
#
# CPU(s): MIPS R3000 Processor Chip Revision: 2.0
# Clock Speed: 20MHz
# Physical RAM: 32MB
# Swap RAM: 
# Storage Device 0 Type: FAST-20 WIDE SCSI
# Storage Device 0 Model: MICROPOLIS 4345WS
# Storage Device 0 Capacity: 4340MB
# Storage Device 1 Type: FAST-10 SCSI
# Storage Device 1 Model: PLEXTOR CD-R   PX-W4220T
# Storage Device 1 Capacity: 128kB Cache
# Video System: GR1.2 Bit-plane, Z-buffer, Turbo options installed
# Video RAM: 
# ---Hope you get the idea, I haven't got the script right for IRIX yet---
#--------------------------------
#


#-------------------------------* hardware pipe *--------------------------------

open (SYSCTLPIPE, "grep CPU\: /var/log/dmesg | cut -c 5- |");
while (<SYSCTLPIPE>) {
	@cpu=chop;
	$cpu_model = $_ ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep Detected /var/log/dmesg | grep Hz | grep processor | cut -f 2 -d ' '|");
while (<SYSCTLPIPE>) {
	@mhz=chop;
	$sys_mhz = $_ / 1000000;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep Memory\: /var/log/dmesg | cut -f 2 -d '/' | cut -f 1 -d 'k'|");
while (<SYSCTLPIPE>) {
	@mem=chop;
	$hw_physmem = $_ / 1024;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "cat /proc/meminfo | grep SwapTotal | cut -c 11-20|");
while (<SYSCTLPIPE>) {
	@swp=chop;
	$hw_swapmem = $_ / 1024 ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep hda:\  /var/log/dmesg | grep , | tail -1| cut -c 6- | grep Cache |");
while (<SYSCTLPIPE>) {
	@hda1=chop;
	$sys_hda1 = $_ ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep hdb:\  /var/log/dmesg | grep , | tail -1| cut -c 6- | grep Cache |");
while (<SYSCTLPIPE>) {
	@hdb1=chop;
	$sys_hdb1 = $_ ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep hdc:\  /var/log/dmesg | grep , | tail -1| cut -c 6- | grep Cache |");
while (<SYSCTLPIPE>) {
	@hdc1=chop;
	$sys_hdc1 = $_ ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "grep hdd:\  /var/log/dmesg | grep , | tail -1| cut -c 6- | grep Cache |");
while (<SYSCTLPIPE>) {
	@hdd1=chop;
	$sys_hdd1 = $_ ;
}
close (SYSCTLPIPE);


open (SYSCTLPIPE, "test -e /proc/pci && cat /proc/pci | grep VGA | cut -f 2 -d : || echo 'No Linux VGA PCI card found'|");
while (<SYSCTLPIPE>) {
	@vga=chop;
	$sys_vga = $_ ;
}
close (SYSCTLPIPE);

#--------------------* generate output  *-----------------

##########################################################################
# *NOTE* the Content-Type line below _MUST_ be followed by a blank line! #
##########################################################################
print "CPU:             $cpu_model\n";
printf "Clock Speed:      %.0f MHz\n", $sys_mhz;
printf "RAM:              %.0f MB\n", $hw_physmem;
printf "Swap:             %.0f MB\n", $hw_swapmem;
print "First IDE Drive:  $sys_hda1\n";
print "Second IDE Drive: $sys_hdb1\n";
print "Thrid IDE Drive:  $sys_hdc1\n";
print "Fourth IDE Drive: $sys_hdd1\n";
print "Video Card:      $sys_vga\n";
