//
// Copyright (C) 1998, Mark W J Redding <grawlfang@ukhackers.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef DATEDURATION_INCLUDE
#define DATEDURATION_INCLUDE

#include <qwidget.h>
#include <qframe.h>
#include <qslider.h>
#include <qlabel.h>
#include <qdatetime.h>

class
DateDuration : public QFrame
{
	private:
	 Q_OBJECT
	 QDate baseDate;
	 QDate currDate;
	 QLabel *FinishDate;
	 QSlider *duration;
	 int realDuration;

	public:
	 DateDuration(int size=30, QWidget *parent=0, char *name=0);
	 ~DateDuration();
	 int getDuration();
	 void setDuration(int, bool slide=true);
	 void setStartDate(QDate&);
	 void setEnabled(bool);
	 QDate& getCurrentDate();

	protected:
	signals:
	 void durationChanged(int);

	public slots:
	 void changeDuration(int);
	 void setCurrentDate(int);
};

#endif
