//
// Copyright (C) 1998, Mark W J Redding <grawlfang@ukhackers.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef EXPORTSELECT_INCLUDE
#define EXPORTSELECT_INCLUDE

#include <qwidget.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qcheckbox.h>

class ExportSelect : public QWidget
{
	private:
	 Q_OBJECT

	private:
	 QButton* Okay;
	 QButton* cancel;
	 QCheckBox* expPublic;
	 QCheckBox* expBusiness;
	 QCheckBox* expPersonnal;
	 QCheckBox* expDay;

	public:
	 ExportSelect(QWidget* parent=0, const char* name=0);
	 ~ExportSelect();
	 bool exportPublic();
	 bool exportBusiness();
	 bool exportPersonnal();
	 bool exportDay();

	protected:
	signals:
	 void exitExport();
	 void quitExport();

	public slots:
	 void exit();
	 void quit();
};

#endif
