//
// Copyright (C) 1999, Mark W J Redding <grawlfang@ukhackers.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

//#define USE_MYSQL

#ifndef KALIO_INCLUDE
#define KALIO_INCLUDE
//
//	The KalIO class performs all application I/O
//
#include <qwidget.h>
#include <qstring.h>
#include <qdatetime.h>
#include <qdatastream.h>
#include <qtextstream.h>
#include <qfile.h>

#ifdef USE_MYSQL
#include "mysql.h"
#endif

#include "KalSocket.h"

class
KalIO
{
	private:
	 KalSocket* soc;

#ifdef USE_MYSQL
	 MYSQL *sql;
	 MYSQL mysql;
	 MYSQL_RES *result[8];
	 MYSQL_ROW row[8];
	 unsigned long *lens[8];
	 bool doInit;
#endif

	 QDataStream ds;
	 QString ufil;
	 QString fileOnDisk;
	 QString host;
	 QFile fil;
	 enum {diskfile,database,network};
	 int ioType;
	 bool fileExists;
	 bool readOnly;
	 int num_cols;
	 int num_rows;

	 int userID;

	public:
	 KalIO(QString*,int);	// network
	 KalIO();		// file system
	 KalIO(QString*);	// database
	 ~KalIO();
	 bool isNetwork();
	 bool isDatabase();
	 void unopen(QString&);
	 bool open(QString&, QString&, bool write=false, bool onlyRead=false);
	 void close();
	 bool exists();
	 void command(char , QString&);
	 void read(QString* , int len=0);
	 void read(int*);
	 void read(QDateTime*);
	 void read(QDate*);
	 void read(bool*);
	 void write(QString& , int);
	 void write(char *);
	 void write(int);
	 void write(QDateTime);
	 void write(QDate);
	 void write(bool);
	 bool lock();
	 void unlock();
	 bool isReadOnly();
	 int select(int,QString&);
	 bool fetch(int);
	 void doneSelect(int);
	 int execute(QString&);
	 char* getString(int,int);
	 int getNumber(int,int);
	 QDate& getDate(int,int);
	 int getUserID();
	 void setUserID(int);
};
#endif

