//
// Copyright (C) 1999, Mark W J Redding <grawlfang@ukhackers.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef KALSOCKET_INCLUDE
#define KALSOCKET_INCLUDE
//
//	The KalSocket class is used to communicate with the server
//
#include <qwidget.h>
#include <qstring.h>
#include <qdatetime.h>

#include <ksock.h>

class
KalSocket
{
	private:
	 int sock;

	public:
	 KalSocket(QString*,int);
	 ~KalSocket();
	 bool command(char, QString&);
	 int read(QString* , int len=0);
	 int read(int*);
	 int read(QDateTime*);
	 int read(QDate*);
	 bool write(QString&);
	 bool write(char *);
	 bool write(int);
	 bool write(QDateTime);
	 bool write(QDate);
	 int getSocket();
	 void close();
	 bool isActive();

	 enum {openRead='R',openWrite='O',saveSession='S',closeSession='C'};
};
#endif

