//
// Copyright (C) 1999, Mark W J Redding <grawlfang@ukhackers.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include "ListUsers.h"

#include "KalIO.h"

#include <kapp.h>
#include <klocale.h>

ListUsers::ListUsers(KalIO* stream, QString* u, QWidget *parent, const char *name)
	: QDialog(parent, name, true)
{
	UserListing = new QListBox(this);
	UserListing->setGeometry(110, 20, 100, 80);
	UserListing->setMouseTracking(true);

	Okay = new QPushButton(klocale->translate("Okay"),this);
	Okay->setGeometry(10, 20, 80, 30);

	Quit = new QPushButton(klocale->translate("Exit"),this);
	Quit->setGeometry(10, 60, 80, 30);

	resize(220,120);

	connect(Okay,SIGNAL(clicked()),SLOT(exit()));
	connect(Quit,SIGNAL(clicked()),SLOT(quit()));
	connect(UserListing,SIGNAL(selected(int)),SLOT(exit(int)));

	rs = u;

	gatherUsers(stream);

}

ListUsers::~ListUsers()
{
	delete UserListing;
	delete Okay;
	delete Quit;
}

//
// signal emitted upon exit
//
void
ListUsers::exit()
{
	int item = UserListing->currentItem();
	exit(item);
}

void
ListUsers::exit(int item)
{
	if(item != -1)
	{
		rs->resize(0);
		rs->append(UserListing->text(item));
		accept();
	}
}

void
ListUsers::quit()
{
	reject();
}

void
ListUsers::gatherUsers(KalIO* stream)
{
QString query;
QString user;

	query.sprintf("select username from users");
	int recs = stream->select(9,query);
	for( int i = 0; i < recs; i++)
	{
		stream->fetch(9);
		user.resize(0);
		user.append(stream->getString(9,0));	
		UserListing->insertItem(user);
	}
	if(recs)
	{
		stream->doneSelect(9);
	}
}

