/* THIS CODE IS LICENSED UNDER THE GPL - SEE 'LICENSE' FOR MORE INFO */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <pwd.h>
#include <ctype.h>
#include <string.h>

#define DEBUG_MODE

struct userinfo
{ 
	char username[32]; 
	char password[8]; 
	char full_name[64]; 
	char groupname[32]; 
	char homedir[256];
	int uid; 
};

void outputf(struct userinfo *cur_user, FILE *output)
{
	fprintf(output,(strlen(cur_user->full_name)<=14?"%s:\t\tuser = %s":
		"%s:\tuser = %s"), cur_user->full_name, cur_user->username);
	fprintf(output,(strlen(cur_user->username)<=8?"\t\tpwd = %s\tuid = %i\n":
		"\tpwd = %s\tuid = %i\n"), cur_user->password, cur_user->uid);
}

void exec(char *line, struct userinfo *cur_user, int test, FILE *output, int times_thru)
{
	int i=0, j=0, k=0;
	char parsed_line[512]; char buffer[16];
	int error;
	
	for(i=0;i<strlen(line);i++)
	{
		if(line[i]!='%')
		{	
			parsed_line[j]=line[i];
			j++;
		}
		else
		{
			k=0;
			switch(line[++i])
			{
				case 'u':
					while(cur_user->username[k]!='\0') 
						parsed_line[j++]=cur_user->username[k++];
					break;
				case 'p':
					while(cur_user->password[k]!='\0') 
						parsed_line[j++]=cur_user->password[k++];
					break;
				case 'd':
					while(cur_user->homedir[k]!='\0') 
						parsed_line[j++]=cur_user->homedir[k++];
					break;
				case 'f':
					while(cur_user->full_name[k]!='\0') 
						parsed_line[j++]=cur_user->full_name[k++];
					break;
				case 'i':
					sprintf(buffer, "%d", cur_user->uid);
					while(buffer[k]!='\0')
						parsed_line[j++]=buffer[k++];
					break;
				case 'g':
					while(cur_user->groupname[k]!='\0') 
						parsed_line[j++]=cur_user->groupname[k++];
					break;
				case '%':
					*parsed_line='%';
					j++;
					break;
			}
		}
	} parsed_line[j]='\0';

#ifdef DEBUG_MODE
	printf("%s\n",parsed_line);
#endif	
	if(!test) 
	{ 
		error = system(parsed_line);
		if(error) fprintf(output, "!%i!!%i! ", (times_thru<64?times_thru:times_thru-64), error);
	}
	if(times_thru >= 64) outputf(cur_user, output);
}

void get_cur_user_info(struct userinfo *cur_user, FILE *stream, char *groupname, char *def_dir)
{  char line[100], *cur_char, *cur_dest;
   char firstname[32], lastname[32], sid[8];
   char username[32]="", full_name[64];
   int uid;

   fgets(line, 100, stream);
   if(feof(stream)) exit(0);
   cur_char=line;

   cur_dest=lastname;
   while(*cur_char!=' ' && *cur_char!='\n' && *cur_char!=',')
   {  *cur_dest=*cur_char; cur_char++; cur_dest++;  }
   *cur_dest='\0'; cur_char++;

   cur_dest=firstname;
   while(*cur_char!=' ' && *cur_char!='\n' && *cur_char!=',')
   {  *cur_dest=*cur_char; cur_char++; cur_dest++;  }
   *cur_dest='\0'; cur_char++;

   strcpy(full_name, firstname);
   strcat(full_name, lastname);

   cur_dest=sid;
   while(*cur_char!='\n' && *cur_char!='\0')
   {  *cur_dest=*cur_char; cur_char++; cur_dest++;  }
   *cur_dest='\0';

   make_user_name(firstname, lastname, username);
   strtlower(username);
   //	strcpy(sid,username); // temporily, this assigns password = username
   make_random_password(sid,6);

   strcpy(cur_user->username,username);
   strcpy(cur_user->password,sid);
   strcpy(cur_user->full_name,full_name);
   strcpy(cur_user->groupname,groupname);
   strcpy(cur_user->homedir,def_dir);
   		strcat(cur_user->homedir,"/");
   		strcat(cur_user->homedir,username);
}

void cmd_parse(char *line_to_parse, struct userinfo *cur_user, char *dest)
{ 
	int i;
	
	for(i=0;i<strlen(*line_to_parse);i++)
	{
		if(line_to_parse[i]!='%')
		{
			*dest=line_to_parse[i];
			dest++;
		}
		else
		{
			i++;
			if(line_to_parse[i]=='u')
				strcat(dest,cur_user->username);
			if(line_to_parse[i]=='p')
				strcat(dest,cur_user->password);
			if(line_to_parse[i]=='f')
				strcat(dest,cur_user->full_name);
			i++;
		}
	}
}

void strtlower(char *source)
{ int i; for(i=0;i<strlen(source);i++) { if(isupper(source[i])) source[i]+=32; } }

void make_random_password(char *dest, int length)
{  int i;
   for(i=0;i<length;i++)
   {  // lowercase a-z = between ranges 97-122
      *(dest+i)=97+(char) ((122.0-97.0)*rand()/(RAND_MAX+1.0));
   }
   *(dest+i)='\0';
}

void make_user_name(char *firstname, char *lastname, char *dest_username)
{  int i;

   // first initial, lastname (ie. pdavis for Peter Davis)
   for(i=0;i<32;i++)
   {
      if(i==0) dest_username[i]=firstname[0];
      if(i>0)	dest_username[i]=lastname[i-1];
   }
   dest_username[(strlen(dest_username))]='\0';
}

int gethighuid(int lowest_desired, int highest_desired, int last_in_passwd_file)
{  int cur_uid, highest_so_far=0;
   while(1)
   {
      cur_uid = getpwent()->pw_uid;
      //	printf("LAST = %i, CUR = %i, HIGH = %i\n", last_in_passwd_file, cur_uid, highest_so_far);
      if(cur_uid>highest_so_far && cur_uid<highest_desired && cur_uid>lowest_desired)
	 highest_so_far=cur_uid;
      if(cur_uid==last_in_passwd_file) break;
   }
   if(highest_so_far<lowest_desired || highest_so_far>highest_desired)
      highest_so_far=lowest_desired;
   return(highest_so_far+1);
}

int  main(int argc, char **argv)
{  time_t seed;
   char  command[64][512];             /* the input line                 */
   struct userinfo cur_user;
   FILE *stream, *output;
   struct settings { int n; int o; int g; int c; int h; int u; int t; int r;} settings;
   int i, j=0;
   int cur_uid, last_uid, low_range, high_range;
   char groupname[32]="";
   char homedir[256]="/home";


   time(&seed);
   srand(seed);

	settings.n=0;settings.o=0;settings.g=0;settings.c=0;settings.h=0;settings.u=0;settings.t=0;settings.r=0;
	for(i=1;i<argc;i++)
	{
		if(argv[i][0]=='-')
		{
			switch(argv[i][1])
			{
				case 'g':
					settings.g=1;
					strcpy(groupname, argv[++i]);
					printf("Group: %s\n", groupname);
					break;
				case 'n':
					settings.n=1;
		   			stream=fopen(argv[++i],"r");
					printf("IF: %s\n", argv[i]);
		   			if(stream==NULL) { printf("Error opening input file!\n"); exit(1); }
					break;
				case 'o':
					settings.o=1;
		   			if(strcmp(argv[++i],"-"))
   					{
   						output=fopen(argv[i],"a");
   						if(output==NULL) { printf("Error opening output file!\n"); exit(1); }
   					}
   					else output=stdout;
   					printf("OF: %s\n", argv[i]);
		   			break;
				case 'h':
					settings.h=1;
					strcpy(homedir, argv[++i]);
					printf("Homedir: %s\n", homedir);
		   			break;
				case 'c':
				  case_c:
					settings.c=1;
					if(i < (argc-1))
					{
						if(!(j<64)) { printf("Aborting!  To many commands!\n"); exit(1); }
						strcpy(command[j],argv[++i]);
						j++;
						goto case_c;
					}
					break;
				case 'u':
					settings.u=1;
					last_uid=atoi(argv[++i]);
					printf("Last UID: %d\n", last_uid);
					break;
				case 't':
					settings.t=1;
					break;
				case 'r':
					settings.r=1;
					low_range=atoi(argv[++i]);
					high_range=atoi(argv[++i]);
					break;
			}
		}
   	}
   	if(!settings.c) { printf("Aborting!  You forgot to specify the program to run (-c ...)!\n"); exit(1); }
   	if(!settings.h) { printf("Warning: no default home directory specified... Assuming /home\n"); strcpy(homedir,"/home"); }
   	if(!settings.o) { printf("Warning: no output file specified... Assuming stdout\n"); output=stdout; }
   	if(!settings.n) { printf("Aborting!  No list of names specified!\n"); exit(1); }
   	if(!settings.u) { printf("Aborting!  You must specify the last uid in /etc/passwd!\n"); exit(1); }
   	if(!settings.g) { printf("Warning: no group name specified... Assuming 'users'\n"); strcpy(groupname, "users"); exit(1); }
	if(settings.t) printf("TEST MODE ENABLED - NOTHING WILL ACTUALLY BE DONE\n");
   	if(!settings.r) { printf("Warning: no range of UIDs specified... Assuming 500 - 1000\n"); low_range=500; high_range=1000; }
   	
   	printf("PDAddUser Executing...\n");

   	cur_uid=gethighuid(low_range,high_range,last_uid);

   	while(!(feof(stream)))
	{
		cur_user.uid=cur_uid;
        get_cur_user_info(&cur_user, stream, groupname, homedir);
		cur_uid++;

		for(i=0; i<j; i++)
		{
			if(i<(j-1)) exec(command[i],&cur_user,settings.t,output,i);
			else exec(command[i],&cur_user,settings.t,output,64+i);
		}
   }
   
	return(0);
}
