#!/bin/sh
# ****Hey XEmacs this is -*- tcl -*- ..., Please give me the correct mode ;-)
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*#
#                                                                            #
#                                 tkFTP 1.0.1                                #
#                                                                            #
#                            Version: 1.0       revision: 1                  #
#                                                                            #
#                         an FTP client written in Tcl/Tk                    #
#                                                                            #
#                             (FTP core version 0.7)                         #
#                                                                            #
#                            Copyright (C) 1998-1999                         #
#                                                                            #
#                                 Pascal Jermini                             #
#                            <redoctober@bluewin.ch>                         #
#                                                                            #
#                                   Firebird                                 #
#                              <firebird@chez.com>                           #
#                                                                            #
#                      http://a.trevano.ch/~jermini/tkftp/                   #
#                                                                            #
#  This program is free software; you can redistribute it and/or             #
#  modify it under the terms of the GNU General Public License as            #
#  published by the Free Software Foundation; either version 2 of the        #
#  License, or (at your option) any later version.                           #
#                                                                            #
#  This program is distributed in the hope that it will be useful, but       #
#  WITHOUT ANY WARRANTY; without even the implied warranty of                #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU          #
#  General Public License for more details.                                  #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.#
#                                                                            #
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*#
#
# \
exec $WISH "$0" "$@"
# check the Tcl version...

if {$tcl_version < 8.0} {
    puts stderr "Error: Version of Tcl is lower than 8.0"
    exit
}
if {$tk_version < 8.0} {
    puts stderr "Error: Version of Tk is lower than 8.0"
    exit
}

variable appInfo

# Setting the TKFTP_LIB_DIR
set TKFTP_LIB_DIR "."

#******************************************
#    Version Informations, please don't
#    modify anything...thx
#******************************************
set appInfo(majorVer) 1
set appInfo(minorVer) 0
set appInfo(revLevel) 1
#*************END*************************

variable ftpVars
variable options
set ftpVars(lastMsgCode) "test_string"

# setting the graphics
set graphic_about "${TKFTP_LIB_DIR}/tkFTP_about.gif"
set imAbout_x 163
set imAbout_y 51

# (x/y scale must be 10 points more than real one)
set graphic_main "${TKFTP_LIB_DIR}/tkFTP_main.gif"
set imMain_x 543
set imMain_y 58

set graphic_config "${TKFTP_LIB_DIR}/tkFTP_conf.gif"
set imConfig_x 325
set imConfig_y 65

set iconPixmap "@${TKFTP_LIB_DIR}/tkFTP_icon.xbm"

# if {([info exists env(TKFTP_LIB_DIR)] == 0) || ($env(TKFTP_LIB_DIR) == "")} {
#     puts "tkFTP: error: the variable TKFTP_LIB_DIR is not set. It should point to the directory where tkftp.tcl is located."
#     exit
# }

# sets rcfile
set rcfile $env(HOME)/.tkFTPrc
# create the rcfile if it does not exist
if [file exists $rcfile] {
  set file "[open $rcfile r]"
} else {
  set file "[open $rcfile a]"
}
# protect the file
exec chmod 600 $rcfile

if {($env(WISH) == "wishstep8.0")} {
    set tkstepOptimized 1
    set hoverColor "lightgrey"
} {
    set tkstepOptimized 0
    set hoverColor "grey70"
}

#**********************************************
# Reads the RC file for the user options...
#**********************************************

proc readUserOptions {} {

    variable options

    openRCFile

    # OK, we can get the default password...
    set reply [scanFile "DefaultEMail" retOnFirstMatch]
    if {$reply != 0} {
	regsub "DefaultEMail=" $reply "" reply
	set options(email) $reply
    } else {
	set options(email) 0
    }

    # OK, now we can get the Logging option...
    set reply [scanFile "LogXFers" retOnFirstMatch]
    # if returns 0, then the string has not been found...
    if {$reply == 0} {
	set options(log) 0
	set options(logDir) 0
	set options(logSize) 0
	return
    } else {
	# the key has been found...now shall we log???
	regsub "LogXFers=" $reply "" reply
	if {[string toupper $reply] == "YES"} {
	    set options(log) 1
	} else {
	    set options(log) 0
	    set options(logDir) 0
	    set options(logSize) 0
	    return
	}
    }
    # ok now we can try to search for the path of the logfile...
    set reply [scanFile "LogPath" retOnFirstMatch]
    if {$reply != 0} {
	# the key has been found...where shall we log???
	regsub "LogPath=" $reply "" reply
	# check for the validity of the path...
	if {[file isdirectory $reply] == 0} {
	    set button [tk_messageBox -icon error -type ok \
			    -title Error -parent $x\
			    -message "Initialization error: \"$reply\" is not a valid directory for logging. Using ~/ as logging directory."]
	    set reply "~/"
	}
	set options(logDir) $reply
    } else {
	set options(logDir) "~/"
	# if none specified: use ~/
    }
    # very well, next item? the maximum log size (if not specified: maxSize=0)
    set reply [scanFile "LogMaxSize" retOnFirstMatch]
    if {$reply != 0} {
	# the key has been found...now extract the size
	regsub "LogMaxSize=" $reply "" reply
	# check for non-numerical sizes
	if {[regexp -- \[^0-9\] $reply] == 1} {
	    tk_messageBox -icon error -type ok \
		-title Error -parent $x\
		-message "Initialization error: $logSize is not a valid number for the maximum log size! Using unlimited log size."
	    set reply 0
	}
	set options(logSize) $reply
    } else {
	set options(logSize) 0
    }
    openLogFile
}
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
#
#               G U I 
#
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-


proc guiInit {} {
    createFrames
    createBanner
    createStatusBox
    createLocalFilelist
    createRemoteFilelist
    createLocalEntrybox
    createRemoteEntrybox

    pack .fileListBoxes

    createCommonButtons
    createStatusBar
    createPgBar
    createLocalButtons
    createRemoteButtons
    setBindings
}

#***********************************
# creates all the needed frames...
#***********************************
proc createFrames {} {
    
    frame .fileListBoxes
}
#-----------------------------------
# insert the selected graphic if any
# is defined !
#----------------------------------
proc createBanner {} {
    global imMain_x imMain_y graphic_main
    set imMain_x1 [expr ($imMain_x-10)]
    set imMain_y1 [expr ($imMain_y-10)]
    
    label .banner -width 540
#    place .banner -y 4 -x [expr (270-$imMain_x1/2)]
pack .banner
    canvas .banner.c -height $imMain_y1 -width $imMain_x1
    .banner.c create image [expr $imMain_x1 / 2] [expr $imMain_y1 / 2] -anchor center -image [image create photo -file $graphic_main]

    pack .banner.c -side left
#    pack .banner -side top

}

#--------------------------------------
# The Status Bar
#--------------------------------------
proc createStatusBar {} {
    global appInfo

    frame .status
    label .status.statusBar -relief sunken -width 75 -text "Welcome to tkFTP v$appInfo(majorVer).$appInfo(minorVer).$appInfo(revLevel)"
#    place .statusBar -x 7 -y [expr ($y+$imMain_y)]
    pack .status.statusBar -pady 1m
    pack .status -pady 1m
}

#--------------------------
# The progress Bar
#------------------------
proc createPgBar {} {
    global pgBar tkstepOptimized
    if {$tkstepOptimized == 1} {
	set bgColor gray
    } else {
	set bgColor gray90
    }

    frame .pgBar

    set pgBar .pgBar.pgBar

    canvas $pgBar -width 530 -height 20 \
	-xscrollincrement 10 -yscrollincrement 10 -bd 2
    
    pack $pgBar
    pack .pgBar -expand true -fill both -pady 1m
    
    $pgBar create rectangle 0 0 525 19 -fill $bgColor -outline black
}

#-------------------------------------
# Some common button (i.e.: Connect,
# quit, etc..
#-------------------------------------
proc createCommonButtons {} {
    global hoverColor

    frame .bottomBttns
    # buttons on the bottom...(connect, abort, about, quit)
    button  .bottomBttns.connectBttn -text "Connect" \
	-command "manageConnectIface" -activebackground $hoverColor
    button  .bottomBttns.abortBttn -text "Abort" -command "abortCurrentAction"\
	-fg red -activeforeground red -state disabled \
	-activebackground $hoverColor
    button  .bottomBttns.clearLogBttn -text "Clear Log" -command "clrLog"\
	-activebackground $hoverColor
    button  .bottomBttns.confBttn -text "Configure" -command "confPanelInit"\
	-activebackground $hoverColor
    button  .bottomBttns.aboutBttn -text "About" -command "about"\
	-activebackground $hoverColor
    button  .bottomBttns.quitBttn -text "Quit" -command "exitProg"\
	-activebackground $hoverColor

    grid .bottomBttns.connectBttn .bottomBttns.abortBttn \
	.bottomBttns.clearLogBttn .bottomBttns.confBttn \
	.bottomBttns.aboutBttn .bottomBttns.quitBttn -padx 2m -pady 2m
    pack .bottomBttns

    # "transfer buttons" (-> & <-)
    set w [frame .fileListBoxes.commonBttns]
    button $w.localToRemoteBttn -text "->" -command "showLocalSel"\
	-activebackground $hoverColor -state disabled
    button $w.remoteToLocalBttn -text "<-" -command "doRemoteAction"\
	-activebackground $hoverColor -state disabled

    grid $w.localToRemoteBttn -column 0 -row 0 -pady 1m
    grid $w.remoteToLocalBttn -column 0 -row 1 -pady 1m

    grid $w -column 2 -row 0
}

#-----------------------------------
# Creates the buttons needed for
# the _local_ directory management
# (rmdir, mkdir, etc)
#----------------------------------
proc createLocalButtons {} {
    global hoverColor

    set w [frame .fileListBoxes.localBttns]
    
    button $w.lMkdirBttn -text "mkdir" -command "lMkdir" -width 4\
	-activebackground $hoverColor
    button $w.lRmdirBttn -text "rmdir" -command "lRmdir" -width 4\
	-activebackground $hoverColor
    button $w.lRmBttn -text "rm" -command "lRm" -width 4\
	-activebackground $hoverColor
    button $w.lRenBttn -text "Rename" -command "lRen" -width 4\
	-activebackground $hoverColor
    button $w.lRefrshBttn -text "Refresh" -command "updateLocalDirList" \
	-width 4 -activebackground $hoverColor
    button $w.lUpBttn -text "-^" -command "global localDir \n set localDir .. \n cd .. \n loadLocalDir \n updateLocalDirList"\
	-width 4 -activebackground $hoverColor

    grid $w.lMkdirBttn  -column 0 -row 0 -pady 1m
    grid $w.lRmdirBttn  -column 0 -row 1 -pady 1m
    grid $w.lRmBttn     -column 0 -row 2 -pady 1m
    grid $w.lRenBttn    -column 0 -row 3 -pady 1m
    grid $w.lRefrshBttn -column 0 -row 4 -pady 1m
    grid $w.lUpBttn     -column 0 -row 5 -pady 1m

    grid $w -column 0 -row 0 -padx 0
}

#-----------------------------------
# Creates the buttons needed for
# the _remote_ directory management
# (rmdir, mkdir, etc)
#----------------------------------
proc createRemoteButtons {} {
    global hoverColor
    
    set w [frame .fileListBoxes.remoteBttns]

    button $w.rMkdirBttn -text "mkdir" -command "rMkdir" -width 4\
	-activebackground $hoverColor -state disabled
    button $w.rRmdirBttn -text "rmdir" -command "rRmdir" -width 4\
	-activebackground $hoverColor -state disabled
    button $w.rRmBttn -text "rm" -command "rRm" -width 4\
	-activebackground $hoverColor -state disabled
    button $w.rRenBttn -text "Rename" -command "rRen" -width 4\
	-activebackground $hoverColor -state disabled
    button $w.rRefrshBttn -text "Refresh" -command "rlist" -width 4\
	-activebackground $hoverColor -state disabled
    button $w.rUpBttn -text "^-" -command "lcwd .. \n rlist" -width 4\
	-activebackground $hoverColor -state disabled

    grid $w.rMkdirBttn  -column 0 -row 0 -pady 1m
    grid $w.rRmdirBttn  -column 0 -row 1 -pady 1m
    grid $w.rRmBttn     -column 0 -row 2 -pady 1m
    grid $w.rRenBttn    -column 0 -row 3 -pady 1m
    grid $w.rRefrshBttn -column 0 -row 4 -pady 1m
    grid $w.rUpBttn     -column 0 -row 5 -pady 1m

    grid $w -column 4 -row 0 -padx 0
}

#********************************
# Checks the situation: if there
# is an active connection, then
# ask for disconn., else show
# connection dialog box...
#
# Args:
#*******************************
proc manageConnectIface {} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	cb_DrawIface
    } else {
	ask4connectionBreak
    }
}

#***********************************
# Asks for a confirmation of breaking
# the current connection...
#
# Args:
#**********************************
proc ask4connectionBreak {} {
    set button [tk_messageBox -icon question -type yesno \
		    -title Confirmation -parent . \
		    -message "Are you sure that you want to break the current connection?"]
    
    if {$button == "no"} {
	return 1
    } else {
	quit
    }
}
proc cleanVars {} {
    .fileListBoxes.remoteBttns.rMkdirBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRmdirBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRmBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRenBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRefrshBttn configure -state disabled
    .fileListBoxes.remoteBttns.rUpBttn configure -state disabled
    .bottomBttns.connectBttn configure -text "Connect"
    .fileListBoxes.commonBttns.localToRemoteBttn configure -state disabled
    .fileListBoxes.commonBttns.remoteToLocalBttn configure -state disabled
    .fileListBoxes.remoteList.list delete 0 end
    bind .fileListBoxes.remoteEntry <Return> ""
    wm title . "tkFTP: Not Connected"
    wm iconname . "tkFTP: Not Connected"
    .status.statusBar configure -text "tkFTP: Not Connected"
    .fileListBoxes.remoteEntry delete 0 end
    # wipe out some old data....
    set ftpVars(cmdStatus) ""
    set ftpVars(jobDone) ""
    set ftpVars(lastMsgCode) ""
    set ftpVars(lastCmd) ""
    set ftpVars(jobDone) 1
}

#***********************
# Connect box management
#      BEGIN
#***********************
proc cb_DrawIface {} {
    global cboxHandle

    set cboxHandle .connectIface
    set x $cboxHandle

    catch {destroy $x}
    toplevel $x
    wm title $x "Connect to"
    wm iconname $x "Connect to"
    wm resizable $x 0 0

    cb_SetBttns
    cb_SetEntryBoxes
    cb_SetProfileList

    pack $x.plFrame -side top -pady 2m
    pack $x.infoBox -side top -pady 2m
    pack $x.bttnFrame -side top -pady 2m

    tkwait visibility $x
    raise $x
    grab set $x
}

proc cb_SetBttns {} {
    global cboxHandle hoverColor
    set x $cboxHandle

    frame $x.bttnFrame
    set w $x.bttnFrame

    button $w.goBttn -text "Connect" -command "cb_ExtractParms" -under 0\
	-activebackground $hoverColor
    button $w.cancBttn -text "Cancel" -command "cb_DestroyIface" -under 1\
	-activebackground $hoverColor
    button $w.saveBttn -text "Save Profile" -command "cb_SaveProfile" -under 0\
	-activebackground $hoverColor
    button $w.delBttn -text "Delete Profile" -command "cb_DeleteProfile" \
	-activebackground $hoverColor -under 0

    grid $w.saveBttn $w.delBttn -row 0 -pady 1m -padx 1m
    grid $w.goBttn $w.cancBttn -row 1 -pady 1m -padx 1m

}

proc cb_SetProfileList {} {
    global cboxHandle
    set x $cboxHandle
    frame $x.plFrame
    set w $x.plFrame

    menubutton $w.pList -width 30 -text "Profile List" -relief raised \
	-activebackground white -under 0

    cb_insertPList
    pack $w.pList
}

proc cb_insertPList {} {
    variable cb_ProfileList
    global cboxHandle
    set x $cboxHandle

    if {[info exists cb_ProfileList] == 1} {
	unset cb_ProfileList
    }

    openRCFile
    destroy $x.plFrame.pList.menu
    menu $x.plFrame.pList.menu -tearoff 0

    set profileCount [scanFile Profile= countOnly]

    for {set i 1} {$i<=$profileCount} {incr i} {
	set menuItem [cb_GetProfileEntry $i]
	lappend cb_ProfileList $menuItem
	$x.plFrame.pList.menu add command -label $menuItem -command \
	    "cb_UpdatePList {$menuItem}"
    }
    $x.plFrame.pList configure -menu $x.plFrame.pList.menu
    closeRCFile
}

proc cb_UpdatePList {menuItem} {
    global cboxHandle
    set x $cboxHandle

    $x.plFrame.pList configure -text $menuItem
    cb_DisplayParmsFromRC $menuItem
}

proc cb_DisplayParmsFromRC {menuItem} {
    global cboxHandle
    variable cb_ProfileList

    set x $cboxHandle
    set w $x.infoBox

    cb_ResetEntries

    set itemNum [lsearch -exact $cb_ProfileList $menuItem]
    incr itemNum

    openRCFile

    set profileString [scanFile Profile= searchNum $itemNum]
    
    regsub "Profile=" $profileString "" profileString
    set profileString [addEscapeChars $profileString]

    set profileData [removeEscapeChars [split $profileString :]]

    $w.pnEntry insert 0 [lindex $profileData 0]
    $w.hostEntry insert 0 [lindex $profileData 1]
    $w.portEntry insert 0 [lindex $profileData 2]
    $w.usrEntry insert 0 [lindex $profileData 3]
    $w.passEntry insert 0 [rot13 [lindex $profileData 4]]
    $w.initLDirEntry insert 0 [lindex $profileData 5]
    $w.initRDirEntry insert 0 [lindex $profileData 6]
    $w.commentEntry insert 0 [lindex $profileData 7]
}

proc addEscapeChars {stringBuffer} {

    regsub -all -- "\[\\$]" $stringBuffer "\\$" stringBuffer
    regsub -all -- "\[\[]" $stringBuffer "\\\[" stringBuffer
    return $stringBuffer
}

proc removeEscapeChars {stringBuffer} {

    return [subst $stringBuffer]
}
proc cb_ResetEntries {} {
    global cboxHandle
    set x $cboxHandle
    set w $x.infoBox

    $w.pnEntry delete 0 end
    $w.hostEntry delete 0 end
    $w.portEntry delete 0 end
    $w.usrEntry delete 0 end
    $w.passEntry delete 0 end
    $w.initLDirEntry delete 0 end
    $w.initRDirEntry delete 0 end
    $w.commentEntry delete 0 end
}
proc cutProfileEntries {profileString} {

    set cutOut [string first ":" $profileString]
    set out [string range $profileString 0 [expr ($cutOut-1)]]
    return $out
}
proc cb_GetProfileEntry {itemCount} {

    set profileString [scanFile Profile= searchNum $itemCount]
    
    regsub "Profile=" $profileString "" profileString
    set cutOut [string first ":" $profileString]
    set profileName [string range $profileString 0 [expr ($cutOut-1)]]
    return $profileName
}

proc cb_SetEntryBoxes {} {
    global anonLogin cboxHandle

    set x $cboxHandle
    frame $x.infoBox
    set w $x.infoBox

    label $w.pnLabel -text "Profile Name:" -pady 1m 
    label $w.hostLabel -text "Host:" -pady 1m 
    label $w.portLabel -text "Port:" -pady 1m 
    label $w.usrLabel -text "User Name:" -pady 1m 
    label $w.passLabel -text "Password:" -pady 1m 
    label $w.initLDirLabel -text "Init. Local Dir:" -pady 1m 
    label $w.initRDirLabel -text "Init. Remote Dir:" -pady 1m 
    label $w.commentLabel -text "Comment:" -pady 1m 

    entry $w.pnEntry -width 20 
    entry $w.hostEntry -width 20 
    entry $w.portEntry -width 5 
    entry $w.usrEntry -width 20 
    entry $w.passEntry -width 20 
    $w.passEntry configure -show *
    entry $w.initLDirEntry -width 20 
    entry $w.initRDirEntry -width 20 
    entry $w.commentEntry -width 20 

    checkbutton $w.anonLogin -text "Connect as anonymous" \
 	-command "cb_EvalAnonLogin" -variable anonLogin
    $w.anonLogin deselect

    grid $w.pnLabel       -column 0 -row 0 -sticky "e"
    grid $w.hostLabel     -column 0 -row 1 -sticky "e"
    grid $w.portLabel     -column 0 -row 2 -sticky "e"
    grid $w.anonLogin -   -column 0 -row 3 -sticky "ew"
    grid $w.usrLabel      -column 0 -row 4 -sticky "e"
    grid $w.passLabel     -column 0 -row 5 -sticky "e"
    grid $w.initLDirLabel -column 0 -row 6 -sticky "e"
    grid $w.initRDirLabel -column 0 -row 7 -sticky "e"
    grid $w.commentLabel  -column 0 -row 8 -sticky "e"

    grid $w.pnEntry       -column 1 -row 0 -sticky "ew" -padx 2m
    grid $w.hostEntry     -column 1 -row 1 -sticky "ew" -padx 2m
    grid $w.portEntry     -column 1 -row 2 -sticky "w"  -padx 2m
    grid $w.usrEntry      -column 1 -row 4 -sticky "ew" -padx 2m
    grid $w.passEntry     -column 1 -row 5 -sticky "ew" -padx 2m
    grid $w.initLDirEntry -column 1 -row 6 -sticky "ew" -padx 2m
    grid $w.initRDirEntry -column 1 -row 7 -sticky "ew" -padx 2m
    grid $w.commentEntry  -column 1 -row 8 -sticky "ew" -padx 2m

}

proc cb_EvalAnonLogin {} {
    global cboxHandle
    global anonLogin
    variable options
    set x $cboxHandle
    set w $x.infoBox

    if {$anonLogin == 1} {
	$w.usrEntry delete 0 end
	$w.usrEntry insert 0 "anonymous"
	$w.passEntry delete 0 end
	$w.passEntry insert 0 $options(email)
    } else {
	$w.usrEntry delete 0 end
	$w.passEntry delete 0 end
    }
}
#********************************
# Gets the parameters for the 
# connection to the FTP server
#
# Args:
#********************************
proc cb_ExtractParms {} {
    global cboxHandle ftpInfos
    set x $cboxHandle
    set w $x.infoBox

    set ftpInfos(profileName) [$w.pnEntry get]
    set ftpInfos(ftpServer) [string trim [$w.hostEntry get]]
    set ftpInfos(ftpPort) [$w.portEntry get]
    set ftpInfos(userName) [$w.usrEntry get]
    set ftpInfos(password) [$w.passEntry get]
    set ftpInfos(localInitDir) [$w.initLDirEntry get]
    set ftpInfos(remoteInitDir) [$w.initRDirEntry get]

    # avoid passing zero-length value to the function...this can only mess 
    # up the futures parameters scans...
    if {[string length $ftpInfos(ftpPort)] == 0} {
	set ftpInfos(ftpPort) "-"
    }
    if {[string length $ftpInfos(localInitDir)] == 0} {
	set ftpInfos(localInitDir) [pwd]
    }
    if {[string length $ftpInfos(remoteInitDir)] == 0} {
	set ftpInfos(remoteInitDir) "/"
    }
    cb_DestroyIface

    if {[connectToServer $ftpInfos(ftpServer) $ftpInfos(ftpPort)\
	     $ftpInfos(userName) $ftpInfos(password) \
	     $ftpInfos(localInitDir) $ftpInfos(remoteInitDir)] == 1} {
	wm title . "tkFTP: $ftpInfos(profileName) ($ftpInfos(ftpServer))"
	wm iconname . "tkFTP: $ftpInfos(profileName) ($ftpInfos(ftpServer))"
	.bottomBttns.connectBttn configure -text "Disconnect"
    }
}

proc cb_DestroyIface {} {
    global cboxHandle cb_ProfileList
    if {[info exist cb_ProfileList] == 1} {
	unset cb_ProfileList
    }
    catch {grab release $cboxHandle}
    catch {destroy $cboxHandle}
}

proc cb_DeleteProfile {} {
    global cboxHandle
    set x $cboxHandle
    set w $x.infoBox
    variable fileHandlers

    set profile [string trim [$w.pnEntry get]]
    if {[string length $profile] == 0} {
	return
    }

    openRCFile
    set wholeRC [getWholeFile rcFile]
    closeRCFile

    set fileHandlers(newrcFile) [open ~/.tkFTPrc.new w]
    fconfigure $fileHandlers(newrcFile) -buffering none
    for {set i 0} {$i<[expr [llength $wholeRC]-1]} {incr i} {
	set workingOn [string trim [lindex $wholeRC $i]]
	set temp $workingOn
	regsub "Profile=" $temp "" temp
	set temp [cutProfileEntries $temp]
	if {[string compare $temp $profile] != 0} {
	    puts $fileHandlers(newrcFile) $workingOn
	}
    }

    close $fileHandlers(newrcFile)

    file copy -force -- "~/.tkFTPrc.new" "~/.tkFTPrc"
    file delete "~/.tkFTPrc.new"

    cb_ResetEntries
    cb_insertPList

}

proc cb_SaveProfile {} {
    global cboxHandle cb_ProfileList
    set x $cboxHandle
    set w $x.infoBox
    variable fileHandlers
    variable options

    set profileName [$w.pnEntry get]
    set ftpServer [$w.hostEntry get]
    set ftpPort [$w.portEntry get]
    set userName [$w.usrEntry get]
    set password [$w.passEntry get]
    set localInitDir [$w.initLDirEntry get]
    set remoteInitDir [$w.initRDirEntry get]
    set comment [$w.commentEntry get]

    set encryptedPass [rot13 $password]

    # sets uncompleted fields
    if {$ftpPort == ""} {set ftpPort 21}
    if {$userName == ""} {set userName anonymous}
    if {($password == "") && ($userName == "anonymous")} {
	set password $options(email)
	set encryptedPass [rot13 $password]
    }
    if {$localInitDir == ""} {set localInitDir ~/}
    if {$remoteInitDir == ""} {set remoteInitDir /}
    if {$comment == ""} {set comment "none entered"}

    set profileString "Profile=$profileName:$ftpServer:$ftpPort:$userName:$encryptedPass:$localInitDir:$remoteInitDir:$comment"
    if {[info exists cb_ProfileList] != 1} {
	set cb_ProfileList ""
    } elseif {$profileName == "" || $ftpServer == ""} {
	tk_messageBox -icon error -type ok -title "Error in profile saving!" \
	    -parent $x -message "You haven't specified the FTP server and/or the profile name! Please specify them!"
	return
    }
    if {[lsearch -exact $cb_ProfileList $profileName] != -1} {
	set button [tk_messageBox -icon question -type yesno -title \
			Overwrite?  -parent . -message \
			"A profile called \"$profileName\" already exists. Overwrite it?"]

	if {$button == "no"} {
	    return
	} else {
	    cb_DeleteProfile
	}
    }
    openRCFile
    seek $fileHandlers(rcFile) 0 end
    puts $fileHandlers(rcFile) $profileString
    closeRCFile
    
    cb_ResetEntries
    cb_insertPList
    cb_UpdatePList $profileName
    return
}

proc rot13 {pass} {
    set abc "abcdefghijklmnopqrstuvwxyz"
    set ABC "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    
    
    set len [llength "$pass"]
    set newline ""
    for {set i 0} {$i < [string length "$pass"]} {incr i} {
	set char "[string index "$pass" $i]"
	set j [string first "$char" "$abc"]
	if {$j != -1} {
	    append newline "[string index "$abc" [expr ($j+13)%26]]"
	    continue
	}
	set j [string first "$char" "$ABC"]
	if {$j != -1} {
	    append newline "[string index "$ABC" [expr ($j+13)%26]]"
	    continue
	}
	append newline "$char"
    }
    return $newline
}

proc openRCFile {} {
    variable fileHandlers

    set fileHandlers(rcFile) [open ~/.tkFTPrc r+]
    fconfigure $fileHandlers(rcFile) -buffering none
}

proc closeRCFile {} {
    variable fileHandlers

    close $fileHandlers(rcFile)
}

proc scanFile {target mode {matchNum {}}} {
    variable fileHandlers

    seek $fileHandlers(rcFile) 0
    set count 0

    while {[eof $fileHandlers(rcFile)]!=1} {
	set buffer [gets $fileHandlers(rcFile)]

	if {[regexp -- $target $buffer] == 1} {
	    switch -- $mode {
		retOnFirstMatch {
		    return $buffer
		}
		searchNum {
		    incr count
		    if {$count == $matchNum} {
			return $buffer
		    }
		}
		countOnly {
		    incr count
		}
	    }
	}
    }
    return $count
}

proc getWholeFile {handler} {
    global fileHandlers

    set retBuffer [list]

    while {[eof $fileHandlers($handler)]!=1} {
	set buffer [gets $fileHandlers($handler)]
	lappend retBuffer $buffer
    }
    return $retBuffer
}

#***********************
# Connect box management
#      END
#***********************
proc exitProg {} {
    variable ftpVars
    variable options

    if {$ftpVars(connected) == 1} {
	if {[ask4connectionBreak] == 1} {
	    return
	}
    }
    # if log open...close it...
    if {$options(log) == 1} {
	closeLogFile
    }
    grab release .
    destroy .
}

proc clrLog {} {
    .statusBox.text configure -state normal
    .statusBox.text delete 1.0 end
    .statusBox.text configure -state disabled
}

#****************************************
# This is the connect procedure (sends
# the username, pwd, ev. init dirs..
#
# Args: ftpServer ===> IP or FQDN of FTP server
#       ftpPort ===> TCP Port
#       userName ===> trivial
#       password ===> should I explain????
#       localInitDir ===> initial local dir.
#       remoteInitDir ==> initial remote dir.
#*****************************************
proc connectToServer {ftpServer ftpPort userName password localInitDir remoteInitDir} {
    global dirs
    variable ftpVars

    # if no login is specified, use the standard login (anonymous)
    if {$userName == ""} {
	set userName anonymous
    }
    # if no server is specified, use Firebird's FTP login (firebird.cybourse.be:21)
    if {$ftpServer == ""} {
	set ftpServer firebird.cybourse.be
	set ftpPort 21
    }
    if {[openFTPLink $ftpServer $ftpPort] != -1} {
	wait4Completion
	if {$ftpVars(cmdStatus) != "conn_failed"} {
	    user
	    # check for the connection...
	    if {$ftpVars(connected) == 1} {
		.fileListBoxes.commonBttns.localToRemoteBttn configure\
		    -state normal
		.fileListBoxes.commonBttns.remoteToLocalBttn configure \
		    -state normal
		.fileListBoxes.remoteBttns.rMkdirBttn configure -state normal
		.fileListBoxes.remoteBttns.rRmdirBttn configure -state normal
		.fileListBoxes.remoteBttns.rRmBttn configure -state normal
		.fileListBoxes.remoteBttns.rRenBttn configure -state normal
		.fileListBoxes.remoteBttns.rRefrshBttn configure -state normal
		.fileListBoxes.remoteBttns.rUpBttn configure -state normal
		.fileListBoxes.localEntry delete 0 end
		.fileListBoxes.localEntry insert 0 $localInitDir
		.fileListBoxes.remoteEntry delete 0 end
		.fileListBoxes.remoteEntry insert 0 $remoteInitDir
		bind .fileListBoxes.remoteEntry <Return> "tryCwd"
		updateLocalDirList
		lcwd $remoteInitDir
		rlist
		return 1
	    }
	} else {
	    cleanVars
	    set ftpVars(connected) 0
	    return 0
	}
    }
}
#-----------------------------------
#  The Local Files
#-----------------------------------
proc createLocalFilelist {} {
    
    font create fnt -family courier -size 12
    frame .fileListBoxes.localList -borderwidth .1c
    pack .fileListBoxes.localList -side top -expand yes -fill y
    scrollbar .fileListBoxes.localList.yscroll \
	-command ".fileListBoxes.localList.list yview"
    scrollbar .fileListBoxes.localList.xscroll -orient horizontal \
	-command ".fileListBoxes.localList.list xview"
    listbox .fileListBoxes.localList.list \
	-yscroll ".fileListBoxes.localList.yscroll set" \
	-xscroll ".fileListBoxes.localList.xscroll set" -setgrid 1 -height 15\
	-font fnt -width 24 -selectmode "extended"
    pack .fileListBoxes.localList.yscroll -side right -fill y
    pack .fileListBoxes.localList.xscroll -side bottom -fill x
    pack .fileListBoxes.localList.list -side left -expand 1 -fill both
#    place .localList -x 40 -y [expr (80+$imMain_y)]
    grid .fileListBoxes.localList -row 0 -column 1
}

#--------------------------------------
# The remote files
#--------------------------------------
proc createRemoteFilelist {} {

    frame .fileListBoxes.remoteList -borderwidth .1c
    pack .fileListBoxes.remoteList -side top -expand yes -fill y
    scrollbar .fileListBoxes.remoteList.yscroll \
	-command ".fileListBoxes.remoteList.list yview" 
    scrollbar .fileListBoxes.remoteList.xscroll -orient horizontal \
	-command ".fileListBoxes.remoteList.list xview"
    listbox .fileListBoxes.remoteList.list \
	-yscroll ".fileListBoxes.remoteList.yscroll set" \
	-xscroll ".fileListBoxes.remoteList.xscroll set"\
	-setgrid 1 -height 15 -font fnt -width 24 -selectmode extended
    pack .fileListBoxes.remoteList.yscroll -side right -fill y
    pack .fileListBoxes.remoteList.xscroll -side bottom -fill x
    pack .fileListBoxes.remoteList.list -side left -expand 1 -fill both
    grid .fileListBoxes.remoteList -row 0 -column 3
}

#------------------------
# Some Entrybox..
#------------------------

# local entrybox
proc createLocalEntrybox {} {

    entry .fileListBoxes.localEntry -width 24
    grid .fileListBoxes.localEntry -column 1 -row 1 -pady 1m -sticky "ew"
    bind .fileListBoxes.localEntry <Return> "updateLocalDirList"
}

# remote entrybox
proc createRemoteEntrybox {} {
    entry .fileListBoxes.remoteEntry -width 24
    grid .fileListBoxes.remoteEntry -column 3 -row 1 -pady 1m -sticky "ew"
}

#------------------------------------
# Creation of the status box
#------------------------------------
proc createStatusBox {} {
    global imMain_y
    
    frame .statusBox
    pack .statusBox -side top -expand yes -fill y
    scrollbar .statusBox.yscroll -command ".statusBox.text yview"
    scrollbar .statusBox.xscroll -orient horizontal -command ".statusBox.text xview" -width 13
    text .statusBox.text -yscroll ".statusBox.yscroll set" -setgrid 1 -height 5 -width 73 \
	-wrap none -state disabled -xscroll ".statusBox.xscroll set"
    pack .statusBox.xscroll -side bottom -fill x
    pack .statusBox.yscroll -side right -fill y
    pack .statusBox.text -side left -expand 1 -fill both
#    place .statusBox -x 1 -y [expr (1+$imMain_y)]
    pack .statusBox -side top

    # create some color binding....
    .statusBox.text tag configure reply1Style -foreground lightpink4
    .statusBox.text tag configure reply2Style -foreground darkgreen
    .statusBox.text tag configure reply3Style -foreground blue
    .statusBox.text tag configure reply4Style -foreground darkorange
    .statusBox.text tag configure reply5Style -foreground red

    .statusBox.text tag configure blue -foreground blue
    .statusBox.text tag configure red -foreground red
    .statusBox.text tag configure purple -foreground purple
}


#---------------------
# Bindings
#--------------------
proc setBindings {} {
    
    bind .fileListBoxes.localList.list <Double-Button-1> "showLocalSel"
    bind .fileListBoxes.remoteList.list <Double-Button-1> "doRemoteAction"
    bind .fileListBoxes.remoteList.list <ButtonRelease-1> "getRemoteVerbose"
}

#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
#
#             G U I Handling (flist handling, etc)
#
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

#----------------------------------
#  Filelists Handling
#----------------------------------
proc updateLocalDirList {} {
    global LocalDir
    set LocalDir [.fileListBoxes.localEntry get]

    if {[file isdirectory $LocalDir] == 1} {
      if {[file readable $LocalDir] == 1} {
        global currentLocalDir
        set currentLocalDir [.fileListBoxes.localEntry get]
        cd [.fileListBoxes.localEntry get]
        loadLocalDir
      } {
      global currentLocalDir
      set LocalDir [.fileListBoxes.localEntry get]
      
      puts "this directory is NOT readable"
      loadLocalDir
      }
    } {
      global currentLocalDir
      set LocalDir [.fileListBoxes.localEntry get]
      
      puts "this is NOT a directory"
      loadLocalDir
    }
}


#***************************************
# Updates the list box for the remote
# files.... is called from getDirList {}
#***************************************
proc updateRemoteDirList {listBuffer} {

    variable remoteList

    # set the parsers for the listings...I have to modify them!!!
    set unixParse {^([^ ])([^ ]+) *[0-9]+ +([^ ]+) +([^ ]+) +([0-9]+) +(............) (((.+) -> (.+))|(.+))}
    set unix2Parse {^([^ ])([^ ]+) *[0-9]+ +([^ ]+) +([0-9]+) +(............) (((.+) -> (.+))|(.+))}
    set winParse {(.................)(......................)(.+)}

    set remoteList(maxLen) 0
    set remoteList(maxSize) 0

    set listBuffer [addEscapeChars $listBuffer]
    set listRows [split $listBuffer "\n"]
    set elemCount 0
    for {set i 0} {$i < [llength $listRows]} {incr i} {
	set k [lindex $listRows $i]
	if {$k == ""} continue
	if {[string  range $k 0 4] == "total"} continue

	incr elemCount
	# Try standard unix parsing...
	set lsType unix
	set reply [regexp $unixParse $k match type flags owner group size date i1 i2 i3 i4]
	if {!$reply} {
	    set lsType unix2
	    # if failed use the second unix listing parsing
	    set r [regexp $unix2Parse $k match type flags owner size date i1 i2 i3 i4]
	    if {!$reply} {
		set lsType win
		# if failed, use Windows parsing...
		set r [regexp $winParse $k match date type i1]
		set i3 ""
		if {!$reply} {
		    updateLog error "Error while interpreting the LIST output..."
		    return
		}
	    }
	}
	# remove all the escape sequences we inserted before...
	set type [removeEscapeChars $type]
	set flags [removeEscapeChars $flags]
	set owner [removeEscapeChars $owner]
	set group [removeEscapeChars $group]
	set size [removeEscapeChars $size]
	set date [removeEscapeChars $date]
	set i1 [removeEscapeChars $i1]
	set i2 [removeEscapeChars $i2]
	set i3 [removeEscapeChars $i3]
	set i4 [removeEscapeChars $i4]

	# now create the lists....
	# btw: **You are not expected to understand this!**"
	if {[string length $i3] != 0} {
	    if {[string length $i3] > $remoteList(maxLen)} {
		set remoteList(maxLen) [string length $i3]
	    } 
	    set remoteList(nameList,$elemCount) $i3
	} else {
	    if {[string length $i1] > $remoteList(maxLen)} {
		set remoteList(maxLen) [string length $i1]
	    }
	    set remoteList(nameList,$elemCount) $i1
	}
	switch -- $lsType {
	    unix {
		set remoteList(ftype,$elemCount) $type
		set remoteList(fileSize,$elemCount) $size
		createUnixVList $flags $owner $group $i1 $i2 $i3 $i4 $elemCount
	    }
	    unix2 {
		set remoteList(ftype,$elemCount) $type
		set remoteList(fileSize,$elemCount) $size
		createUnix2VList $flags $owner $i1 $i2 $i3 $i4 $elemCount
	    }
	    win {
		if {$type == "<DIR>"} {
		    set remoteList(ftype,$elemCount) d
		    set remoteList(fileSize,$elemCount) " "
		} else {
		    set remoteList(ftype,$elemCount) -
		    set remoteList(fileSize,$elemCount) $type
		}
		set remoteList(vList,$elemCount) " "
	    }
	}
	if {[string length $remoteList(fileSize,$elemCount)] > $remoteList(maxSize)} {
	    set remoteList(maxSize) [string length $remoteList(fileSize,$elemCount)]
	}
	set remoteList(fileDate,$elemCount) $date
    }
    incr elemCount
    set elemCount [scanList4Defects $elemCount]
    createRemoteList $elemCount
}

proc scanList4Defects {elemCount} {

    set needCDUP [scanList $elemCount ..]
    set needPWD  [scanList $elemCount .]

    if {$needCDUP == 1} {
	incr elemCount
	addListEntry $elemCount ..
    }
    if {$needPWD == 1} {
	incr elemCount
	addListEntry $elemCount .
    }
    return $elemCount
}

proc addListEntry {elemCount arg} {
    variable remoteList

    set temp(nameList,1) $arg
    set temp(ftype,1) d
    set temp(fileSize,1) ??
    set temp(vList,1) "??  ??  ??"
    set temp(fileDate,1) "??"
    for {set i 1} {$i<[expr ($elemCount-1)]} {incr i} {
	set i [incr i]
	set j [expr ($i-1)]
	set temp(nameList,$i) $remoteList(nameList,$j)
	set temp(ftype,$i) $remoteList(ftype,$j)
	set temp(fileSize,$i) $remoteList(fileSize,$j)
	set temp(vList,$i) $remoteList(vList,$j)
	set temp(fileDate,$i) $remoteList(fileDate,$j)
	
#	set j [incr j]
	set i [expr ($i-1)]
    }
    set temp(maxLen) $remoteList(maxLen)
    set temp(maxSize) $remoteList(maxSize)

    unset remoteList
    variable remoteList
    for {set i 1} {$i<$elemCount} {incr i} {
	set remoteList(nameList,$i) $temp(nameList,$i)
	set remoteList(ftype,$i) $temp(ftype,$i)
	set remoteList(fileSize,$i) $temp(fileSize,$i)
	set remoteList(vList,$i) $temp(vList,$i)
	set remoteList(fileDate,$i) $temp(fileDate,$i)
    }
    set remoteList(maxLen) $temp(maxLen)
    set remoteList(maxSize) $temp(maxSize)
}

proc scanList {elemCount match} {
    variable remoteList
    for {set i 1} {$i<$elemCount} {incr i} {
	set filename [string trim $remoteList(nameList,$i)]
	if {$filename == $match} {
	    return 0
	}
    }
    return 1
}

proc createUnixVList {flags owner group i1 i2 i3 i4 idx} {
    variable remoteList

    set vList "$flags   $owner   $group"
    if {[string length $i4] != 0} {
	set vList "$vList   $i1"
    }
    set remoteList(vList,$idx) $vList
    return
}

proc createUnix2VList {flags owner i1 i2 i3 i4 idx} {
    variable remoteList

    set vList "$flags   $owner"
    if {[string length $i4] != 0} {
	set vList "$vList   $i1"
    }
    set remoteList(vList,$idx) $vList
    return
}
proc createRemoteList {elemCount} {
    variable remoteList

    .fileListBoxes.remoteList.list delete 0 end
    set filler " "

    set maxLen [expr ($remoteList(maxLen) + 2)]
    set maxSizeLen [expr ($remoteList(maxSize)+4)]

    for {set i 1} {$i < $elemCount} {incr i} {
	set workingOn $remoteList(nameList,$i)
	regsub -- "\[\r]" $workingOn "" workingOn
	set remoteList(nameList,$i) $workingOn
	set workingOn [addfType $workingOn $i]
	while {[string length $workingOn] < $maxLen} {
	    append workingOn $filler
	}
	set fsize $remoteList(fileSize,$i)
	for {set padding 1} {$padding < [expr $maxSizeLen - [string length $remoteList(fileSize,$i)]]} {incr padding} {
		append fsize $filler
	}

	set completeName $workingOn$fsize$remoteList(fileDate,$i)
	set completeName $filler$completeName$filler$filler

	.fileListBoxes.remoteList.list insert end $completeName
    }
    return
}

#*********************************
# Adds the symbol of the file type
# (@ for symlinks, / for directories
#
# Args: line ==> line to be processed
#       idx ===> current index of the list
#*********************************
proc addfType {filename idx} {
    variable remoteList

    if {($filename == ".") || ($filename == "..")} {
	return $filename
    }
    switch -- $remoteList(ftype,$idx) {
	l {
	    set workZone [lindex $filename 0]
	    append workZone "@"
	    set filename [lreplace $filename 0 0 $workZone]
	}
	d {
	    append filename "/"
	}
    }

    return $filename
}

proc loadLocalDir {} {
    global currentLocalDir filesName

    set fileDescriptor 2
    set arrayElems 2
    .fileListBoxes.localList.list delete 0 end

    # First take care of all the files except . and .. which aren't included
    # in the globbing....

    # The longest filename is stored above...the first thing we do is checking
    # for the longest filename....
    set nameLen 0
    set maxSizeLen 0
    foreach i [lsort [glob -nocomplain [file join $currentLocalDir *]]] {
	if {[string length [file tail $i]]>$nameLen} {
	    set nameLen [string length [file tail $i]]
	}

	incr fileDescriptor
	incr arrayElems
	set currentFileName [file tail $i]
	# Trick for avoiding the exception if we can't state the file size...
	set currentFileSize [catch {file size $i}]
	# returns 0 if OK, otherwise 1: in the latter case only use "n/a" as 
	# file size....
	if {$currentFileSize == 0} {
	    set filesSize($fileDescriptor) [file size $i]
	} else {
	    set filesSize($fileDescriptor) "n/a"
	}

	# now get mtime for every file...store all this stuff in a list...
	# Trick for avoiding the exception if we can't state the file mtime...
	set currentFileMtime [catch {file mtime $i}]
	# returns 0 if OK, otherwise 1: in the latter case only use "n/a" as 
	# file mtime....
	if {$currentFileMtime == 0} {
	    set mtime($fileDescriptor) [clock format [file mtime $i] -format \
					"%b %d %H:%M"]
	} else {
	    set mtime($fileDescriptor) "n/a"
	}
	# search for the longest size...
	if {[string length $filesSize($fileDescriptor)]>$maxSizeLen} {
	    set maxSizeLen [string length $filesSize($fileDescriptor)]
	}


	# store the current file name in an array for future use....
	set filesName($fileDescriptor) $currentFileName

	# add a slash if file is a directory...
	if {[file isdirectory $currentFileName] == 1} {
	    set filesName($fileDescriptor) $currentFileName/
	}
    }

    # now we can process the special files...
    set filesName(1) "."
    set filesName(2) ".."

    for {set i 1} {$i<3} {incr i} {
	set filesSize($i) [file size $filesName($i)]
	set mtime($i) [clock format [file mtime $filesName($i)]\
			   -format "%b %d %H:%M"]
    }
	# add something more to the max length of the files and sizes
	set nameLen [expr $nameLen + 4]
	set maxSizeLen [expr $maxSizeLen + 4]

	# try to have nice columns of data...
    for {set i 1} {$i < [expr ($arrayElems+1)]} {incr i} {
	set paddingStyle " "
	set nameSizePadding " "
	set sizeMtimePadding " "
	set endPadding "  "
	for {set padding 1} {$padding < [expr $nameLen - [string length $filesName($i)]]} \
	    {incr padding} {
	    append nameSizePadding $paddingStyle
	}
	for {set padding 1} {$padding < [expr $maxSizeLen - [string length $filesSize($i)]]} \
	    {incr padding} {
		append sizeMtimePadding $paddingStyle
	}
	# create a compound object with all the infos....pretty badly designed
	# but it works...
	set completeFile $paddingStyle$filesName($i)$nameSizePadding$filesSize($i)$sizeMtimePadding$mtime($i)$endPadding
	.fileListBoxes.localList.list insert end $completeFile
    }

    # clean up the variables
    unset mtime filesSize fileDescriptor
    
    .fileListBoxes.localList.list activate 1
    
    .fileListBoxes.localEntry delete 0 end
    
    # check if we are on the root directory...if yes don't add an extra slash..
    if {[pwd] == "/"} {
 	.fileListBoxes.localEntry insert 0 [pwd]
    } else {
	 .fileListBoxes.localEntry insert 0 "[pwd]/"
     }
}

#*******************************
# Protects the button of the GUI
# avoiding foolish errors by the
# user while up/downloading
#*******************************
proc protectBttns {} {
    bind .fileListBoxes.localList.list <Double-Button-1> ""
    bind .fileListBoxes.remoteList.list <Double-Button-1> ""
    .fileListBoxes.commonBttns.localToRemoteBttn configure -state disabled
    .fileListBoxes.commonBttns.remoteToLocalBttn configure -state disabled

    .fileListBoxes.remoteBttns.rMkdirBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRmdirBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRmBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRenBttn configure -state disabled
    .fileListBoxes.remoteBttns.rRefrshBttn configure -state disabled
    .fileListBoxes.remoteBttns.rUpBttn configure -state disabled
    bind .fileListBoxes.remoteEntry <Return> ""
}

#*****************************
# Unprotects the buttons....
#*****************************

proc unprotectBttns {} {
    bind .fileListBoxes.localList.list <Double-Button-1> "showLocalSel"
    bind .fileListBoxes.remoteList.list <Double-Button-1> "doRemoteAction"
    .fileListBoxes.commonBttns.localToRemoteBttn configure -state normal
    .fileListBoxes.commonBttns.remoteToLocalBttn configure -state normal

    .fileListBoxes.remoteBttns.rMkdirBttn configure -state normal
    .fileListBoxes.remoteBttns.rRmdirBttn configure -state normal
    .fileListBoxes.remoteBttns.rRmBttn configure -state normal
    .fileListBoxes.remoteBttns.rRenBttn configure -state normal
    .fileListBoxes.remoteBttns.rRefrshBttn configure -state normal
    .fileListBoxes.remoteBttns.rUpBttn configure -state normal
    bind .fileListBoxes.remoteEntry <Return> "tryCwd"
}
proc showLocalSel {} {
    global currentLocalDir
    variable transfer

    set selectedFiles [.fileListBoxes.localList.list curselection]
    if {$selectedFiles == ""} {
	return
    }

    set transfer(totFiles) [llength $selectedFiles]
    set transfer(curFile) 0

    # avoid stupid moves of the user while uploading...
    protectBttns

    foreach i $selectedFiles {
	incr transfer(curFile)
	set realFileName [extractLocalRealFileName $i]

	if {[file isdirectory $realFileName] == 1} {
	    if {[file readable $realFileName] == 1} {
		cd $realFileName
		set currentLocalDir [pwd]
		loadLocalDir
		unprotectBttns
		return
	    } {
		puts "This directory is NOT readable"
		set currentLocalDir [pwd]
		unprotectBttns
		loadLocalDir
		return
	    }
	} else {
	    variable ftpVars
	    if {$ftpVars(connected) == 0} {
		updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
		unprotectBttns
		return
	    }
	    if {[file readable $realFileName] !=1} {
		tk_messageBox -icon error -type ok \
		    -title Error -parent .\
		    -message "Error: the file \"$realFileName\" is not readable."
		continue
	    }
	    beginPutProcess $realFileName
	}
    }
    rlist
    unprotectBttns
}

proc extractLocalRealFileName {descriptor} {
    global filesName
    
    incr descriptor
    return "$filesName($descriptor)"
}

proc doRemoteAction {} {
    variable remoteList
    variable transfer

    # unbind the remote file list...avoid some missplaced operation from the
    # user...
    protectBttns
    set selFiles [.fileListBoxes.remoteList.list curselection]
    if {$selFiles == ""} {
	# rebind...
	unprotectBttns
	return
    }
    
    set transfer(totFiles) [llength $selFiles]
    set transfer(curFile) 0

    foreach realIdx $selFiles {
	incr realIdx
	incr transfer(curFile)
	.status.statusBar configure -text $remoteList(vList,$realIdx)
	switch -- $remoteList(ftype,$realIdx) {
	    d {
		if {$transfer(totFiles) > 1} {
		    updateLog status "Skipping $remoteList(nameList,$realIdx): is a directory."
		    continue
		}
		lcwd $remoteList(nameList,$realIdx)
		rlist
		unprotectBttns
		return
	    }
	    - {
		if {[initiateGetProc $remoteList(nameList,$realIdx) $realIdx] \
			== -1} {
		    continue
		}
		wait4Completion
		continue
	    }
	    l {
		trySymlink $remoteList(nameList,$realIdx) $realIdx
	    }
	}
    }
    unprotectBttns
}
proc trySymlink {fileName idx} {

    variable ftpVars
    set ftpVars(checkingSymLink) 1
 
    # first of all, eliminate this damned @ from the file name!!

    set endingCut [expr ([string length $fileName] - 1)]
    set fileName [string range $fileName 0 $endingCut]

    # first we try to see if the symlink is linking a directory (statistically
    # there are more chance that the target is a directory...):
    # we try to CWD to the symlink: if it changes normally, then it
    # was linking a directory, otherwise this is a file (anyone see 
    # another solution for this heuristic check???)

    if {[lcwd $fileName] == 1} {
	rlist
    } else {
	# ok the CWD has failed (major reply code == 5), try to d/l the file?
	set ftpVars(fileIsSymlink) 1
	initiateGetProc $fileName $idx
    }
    unset ftpVars(checkingSymLink)
    return
}

proc getRemoteVerbose {} {
    variable remoteList

    set remoteFileSelected [lindex [.fileListBoxes.remoteList.list curselection] 0]

    if {$remoteFileSelected == ""} {
	return
    }
    .status.statusBar configure -text $remoteList(vList,[expr ($remoteFileSelected + 1)])
}
#************************************
# sends the log messages to the 
# status box.
#
# Args: text ==> Message to be printed
#       colorStyle ==> color of the text
#************************************
proc updateLog {msgType text {colorStyle ""}} {

    if {[info exists ftpVars(skipLogging)] == 1} {
	return
    }

    .statusBox.text configure -state normal
    switch $msgType {
	error {
	    .statusBox.text insert end "***Error:  " red
	}
	status {
	    .statusBox.text insert end "+++Status: " blue
	}
	cIOSend {
	    .statusBox.text insert end "==> " purple
	}
    }
    .statusBox.text insert end $text $colorStyle
    .statusBox.text insert end "\n"
    .statusBox.text configure -state disabled
    .statusBox.text yview moveto 1.0
}


proc tryCwd {} {
    variable dirs
    
    set target [.fileListBoxes.remoteEntry get]

    if {[lcwd  $target] == "cwdFailed"} {
	lcwd $dirs(oldRemoteDir)
	rlist
	return
    }
    set dirs(oldRemoteDir) $target
    rlist
}
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
#
#               F T P  M A N A G I N G
#
#
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

#*************************************
# Connect the local host to the
# remote one. ==>Open a socket
#
# Args: remoteIP ==> FQDN or decimal dotted IP
#       remotePort ==> telnet port. Default=21
#*************************************

proc openFTPLink {remoteIP {remotePort ""}} {
    variable ftpVars
    variable handlers

    set ftpVars(cmdStatus) welcome

    set ftpVars(chunk) 512

    # if no port is specified, use the standard port (21)
    if {$remotePort == "-"} {
	set remotePort 21
    }
    # open the control channel @ $remoteIP
    updateLog status "Trying to connect to $remoteIP:$remotePort....\n"

    set procAnsw [catch {set ctrlIO [socket $remoteIP $remotePort]}]

    # test if the connection has been established (if $procAnsw!=0 
    # ==> unable to set the var. ctrlIO)
    if {$procAnsw != 0} {
	updateLog error "Connection to the remote host ($remoteIP:$remotePort) has failed...."
	return -1
    }

    set ftpVars(connected) 1
    # configure the IO of the control channel
    fconfigure $ctrlIO -translation {auto crlf} -buffering line -blocking 1
    fileevent $ctrlIO readable readCtrlChannel
    set handlers(ctrlIO) $ctrlIO

    # get the local IP adress, is going to be used in the PORT command 
    # (PORT a1,a2,a3,a4,p1,p2)
    set localIP [lindex [fconfigure $handlers(ctrlIO) -sockname] 0]
    # and transform it...
    regsub -all "\[.]" $localIP "," ftpVars(localIP)
}

#****************************************************************************
# Reads the control channel for messages....is called only when a fileevent
# occurs...
#
# Args:
#****************************************************************************
proc readCtrlChannel {} {
    variable handlers
    variable ftpVars

    # check if the server hanged up the line...
    if {[eof $handlers(ctrlIO)] == 1} {
	catch {close $handlers(dataSocket)}
	catch {close $handlers(ctrlIO)}
	updateLog error "Remote end closed control connection."
	cleanVars
	set ftpVars(connected) 0
	return
    }
    # Read the ctrlIO channel
    set charsRead [gets $handlers(ctrlIO) ctrlIOBuffer]

    # save the message code...can be useful later..
    set ftpVars(lastMsgCode) [lindex $ctrlIOBuffer 0]

    # check for a multi-lines message...(please read RFC959 for infos..)

    set wait4ReplyType [string range $ftpVars(lastMsgCode) 0 2]
    while {$ftpVars(lastMsgCode) != $wait4ReplyType} {
        set currentLine [gets $handlers(ctrlIO)]
	
        set ftpVars(lastMsgCode) [string range $currentLine 0 3]
	
        append ctrlIOBuffer "\n"
        append ctrlIOBuffer $currentLine
    }

    # ok, we have the complete message...now check for the right action to do..
    ftpHandler $ctrlIOBuffer

    return 0
}

#****************************************************************************
# Selects the proper action to do....
#
# Args: ctrlIOBuffer (optional): the messages sent by the server to the ctrl IO
#****************************************************************************
proc ftpHandler {{ctrlIOBuffer {}}} {
    variable ftpVars
    variable ftpInfos
    variable handlers

    if {$ctrlIOBuffer != ""} {

	set majorReplyCode [string range $ctrlIOBuffer 0 0]

	set colorStyle reply[string range $ctrlIOBuffer 0 0]Style
	updateLog default $ctrlIOBuffer $colorStyle
    }
    switch -- $ftpVars(cmdStatus) {
	welcome {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) user
		    set ftpVars(jobDone) 1
		    return
		}
		1 {
		    set ftpVars(cmdStatus) welcome_cont
		    return
		}
		default {
		    set ftpVars(cmdStatus) conn_failed
		    updateLog error "Unable to open a control connection. Aborting."
		    catch {close $handlers(ctrlIO)}
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	welcome_cont {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) user
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) conn_failed
		    updateLog error "Unable to open a control connection. Aborting."
		    catch {close $handlers(ctrlIO)}
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	user {
	    sendToCtrlChannel "USER $ftpInfos(userName)"
	    set ftpVars(cmdStatus) user_sent
	    return 0
	}
	user_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) user_done
		    set ftpVars(jobDone) 1
		    return
		}
		3 {
		    set ftpVars(cmdStatus) user_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) user_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}

	pass {
	    set ftpVars(cmdStatus) pass_sent
	    sendToCtrlChannel "PASS $ftpInfos(password)"
	    return
	}
	pass_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) pass_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while logging in....Wrong Pass?"
		    set ftpVars(cmdStatus) pass_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	type {
	    sendToCtrlChannel "TYPE $ftpVars(xferMode)"
	    set ftpVars(cmdStatus) type_sent
	    return
	}
	type_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) type_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while setting rapresentation type"
		    set ftpVars(cmdStatus) type_failed
		    return
		}
	    }
	}
	list {
	    openDataConnection
	    port
	    wait4Completion
	    set ftpVars(cmdStatus) list_go
	    return
	}
	port {
	    sendToCtrlChannel "PORT $ftpVars(localIP),$ftpVars(DCPort)"
	    set ftpVars(cmdStatus) port_sent
	    return
	}
	port_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) port_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error setting PORT....."
		    return
		}
	    }
	}
	list_go {
	    variable directories
#	    sendToCtrlChannel "LIST -a $directories(remoteCWD)"
	    sendToCtrlChannel "LIST"
	    set ftpVars(cmdStatus) list_sending
	    return
	}
	list_sending {
	    switch -- $majorReplyCode {
		1 {
		    set ftpVars(cmdStatus) list_done
		    return
		}
		default {
		    updateLog error "Error while LISTing"
		    set ftpVars(listOK) 0
		    set ftpVars(cmdStatus) list_failed
		    return
		}
	    }
	}
	list_done {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) list_OK
		    # used by trySymlink()...
		    set ftpVars(listOK) 1
#		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while LISTing"
		    set ftpVars(cmdStatus) list_failed
		    set ftpVars(listOK) 0
		    return
		}
	    }
	}
	quit {
	    sendToCtrlChannel "QUIT"
	    set ftpVars(cmdStatus) quit_sent
	    return
	}
	quit_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while QUITing"
		    return
		}
	    }
	}
	retr {
	    openDataConnection
	    port
	    wait4Completion
	    set ftpVars(cmdStatus) checkRest
	    return
	}
	retr_go {
	    variable transfer
	    updateLog cIOSend "RETR $transfer(remoteFile)"
	    sendToCtrlChannel "RETR $transfer(remoteFile)"
	    set ftpVars(cmdStatus) retr_sending
	    return
	}
	retr_sending {
	    switch -- $majorReplyCode {
		1 {
		    set ftpVars(cmdStatus) retr_done
		    return
		}
		default {
		    updateLog error "Error while retrieving file..."
		    set ftpVars(cmdStatus) retr_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	retr_done {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) retr_ok
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) retr_failed
		    updateLog error "Error while retrieving file...."
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	checkRest {
	    variable transfer
	    if {$transfer(retrMode) == "resume"} {
		rest $transfer(checkPoint)
		wait4Completion
		return
	    } else {
		set ftpVars(cmdStatus) retr_go
		ftpHandler
		return
	    }
	}
	rest {
	    variable transfer
	    sendToCtrlChannel "REST $transfer(checkPoint)"
	    set ftpVars(cmdStatus) rest_done
	    return
	}
	rest_done {
	    switch -- $majorReplyCode {
		3 {
		    set ftpVars(cmdStatus) retr_go
		    ftpHandler
		    return
		}
		default {
		    updateLog error "RESTing ERROR"
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	cwd {
	    variable directories
	    sendToCtrlChannel "CWD $directories(remoteCWD)"
	    set ftpVars(cmdStatus) cwd_done
	    return
	}
	cwd_done {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) cwd_ok
		    set ftpVars(listOK) 1
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) cwd_failed
		    set ftpVars(listOK) 0
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	abor {
	    set ftpVars(cmdStatus) abor_sent
#	    set ftpVars(jobDone) 1
	    return
	}
	abor_sent {
	    set ftpVars(cmdStatus) abor_done
	    set ftpVars(jobDone) 1
	    return
	}
	rnfr {
	    variable rename
	    sendToCtrlChannel "RNFR $rename(target)"
	    set ftpVars(cmdStatus) rnfr_sent
	    return
	}
	rnfr_sent {
	    switch -- $majorReplyCode {
		3 {
		    set ftpVars(cmdStatus) rnfr_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while renaming file..."
		    set ftpVars(cmdStatus) rnfr_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	rnto {
	    variable rename
	    sendToCtrlChannel "RNTO $rename(newTarget)"
	    set ftpVars(cmdStatus) rnto_sent
	    unset rename
	    return
	}
	rnto_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) rnto_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while renaming file..."
		    set ftpVars(cmdStatus) rnto_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	pwd {
	    sendToCtrlChannel "PWD"
	    set ftpVars(cmdStatus) pwd_sent
	    return
	}
	pwd_sent {
	    switch -- $majorReplyCode {
		2 {
		    getRPwd $ctrlIOBuffer
		    set ftpVars(cmdStatus) pwd_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while executing PWD..."
		    set ftpVars(cmdStatus) pwd_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	mkd {
	    variable directories
	    sendToCtrlChannel "MKD $directories(mkd)"
	    set ftpVars(cmdStatus) mkd_sent
	    unset directories(mkd)
	    return
	}
	mkd_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) mkd_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while making directory..."
		    set ftpVars(cmdStatus) mkd_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	rmd {
	    variable directories
	    sendToCtrlChannel "RMD $directories(rmd)"
	    set ftpVars(cmdStatus) rmd_sent
	    unset directories(rmd)
	    return
	}
	rmd_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) rmd_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while removing directory..."
		    set ftpVars(cmdStatus) rmd_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	dele {
	    variable dele_target
	    sendToCtrlChannel "DELE $dele_target"
	    set ftpVars(cmdStatus) dele_sent
	    unset dele_target
	    return
	}
	dele_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) dele_done
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    updateLog error "Error while removing file..."
		    set ftpVars(cmdStatus) dele_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	stor {
	    openDataConnection
	    port
	    wait4Completion
	    set ftpVars(cmdStatus) stor_go
	    return
	}
	stor_go {
	    variable transfer
	    updateLog cIOSend "STOR $transfer(localFile)"
	    sendToCtrlChannel "STOR $transfer(localFile)"
	    set ftpVars(cmdStatus) stor_sending
	    return
	}
	stor_sending {
	    switch -- $majorReplyCode {
		1 {
		    set ftpVars(cmdStatus) stor_done
		    wait4Completion
		    return
		}
		default {
		    updateLog error "Error while storing file..."
		    set ftpVars(cmdStatus) stor_failed
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	stor_done {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) stor_ok
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) stor_failed
		    updateLog error "Error while storing file...."
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	syst {
	    sendToCtrlChannel "SYST"
	    set ftpVars(cmdStatus) syst_sent
	    return
	}
	syst_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) syst_ok
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) syst_failed
		    updateLog error "Error while querying the remote system type"
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	stat {
	    sendToCtrlChannel "STAT"
	    set ftpVars(cmdStatus) stat_sent
	    return
	}
	stat_sent {
	    switch -- $majorReplyCode {
		2 {
		    set ftpVars(cmdStatus) stat_ok
		    set ftpVars(jobDone) 1
		    return
		}
		default {
		    set ftpVars(cmdStatus) stat_failed
		    updateLog error "Error while querying remote system status"
		    set ftpVars(jobDone) 1
		    return
		}
	    }
	}
	default {
	    return
	}
    }
}
#*************************************
# Send the commands to the control
# channel.
#
# Args: command ==> command to be sent
#                   to the control channel
#*************************************

proc sendToCtrlChannel {command} {
    variable ftpVars
    variable handlers

    if {$ftpVars(connected) != 1} {
	return
    }
    
    puts $handlers(ctrlIO) $command
    flush $handlers(ctrlIO)
    return
}

#*************************************************
# Prepare the file to be received from the server
#
# Args: fileName ==> file to be transferred
#************************************************
proc initiateGetProc {fileName fileDescriptor} {
    
    variable ftVars

    # First, check if the file exists locally...
    switch -- [checkFileExists $fileName $fileDescriptor] {
	0 {
	    # The file doesn't exists locally
	    getFileSize $fileDescriptor
	    getNewFile $fileName $fileName
	    return
	}
	1 {
	    # The file exists locally, but is a directory
	    queryAction $fileName 1
	    return
	}
	2 {
	    # The file exists and his length is < than the remote one...
	    if {[file writable $fileName] == 0} {
		if {[writeLockError 1 $fileName] == 0} {
		    return -1
		} else {
		    if {[initiateGetProc $fileName $fileDescriptor] == -1} {
			return -1
		    }
		    return
		}
	    }
	    getFileSize $fileDescriptor
	    queryAction $fileName 2
	    return
	}
	3 {
	    # The file exists and his length is = than the remote one...
	    if {[file writable $fileName] == 0} {
		if {[writeLockError 1 $fileName] == 0} {
		    return -1
		} else {
		    if {[initiateGetProc $fileName $fileDescriptor] == -1} {
			return -1
		    }
		    return
		}
	    }
	    getFileSize $fileDescriptor
	    queryAction $fileName 3
	    return
	}
	4 {
	    # The file exists and his length is = than the remote one...
	    if {[file writable $fileName] == 0} {
		if {[writeLockError 1 $fileName] == 0} {
		    return -1
		} else {
		    if {[initiateGetProc $fileName $fileDescriptor] == -1} {
			return -1
		    }
		    return
		}
	    }
	    getFileSize $fileDescriptor
	    queryAction $fileName 4
	    return
	}
    }
}

proc getFileSize {fileDescriptor} {
    variable remoteList 
    variable transfer

    set transfer(fileSize) $remoteList(fileSize,$fileDescriptor)
}
#**************************************************
# If there is some special case of xfer, ask
# the user for the action...
#
# Args: errCode ==> Exception type
#**************************************************
proc queryAction {fileName errCode} {
    global hoverColor
    set w .queryActionBox

    catch {destroy $w}
    toplevel $w
    tkwait visibility $w
    wm title $w "File exists!"
    wm iconname $w "Error"
    wm resizable $w 0 0

    set x [frame $w.labsFrame]
    set y [frame $w.bttnFrame]

    label $x.infoLabel -text "The file you're going to download already exists on this machine."
    label $x.fnameLabel -text "File: $fileName" -justify center -width 50

    grid $x.infoLabel -row 0 -sticky "ew"
    grid $x.fnameLabel -row 1 -sticky "ew"

    button $y.resume -text "Resume" -command "takeAction resume $fileName" \
    -activebackground $hoverColor
    button $y.rename -text "Rename" -command "takeAction rename $fileName" \
    -activebackground $hoverColor
    button $y.ovrwrt -text "Overwrite" -command "takeAction ovrwrt $fileName" \
    -activebackground $hoverColor
    button $y.cancel -text "Cancel" -command "takeAction cancel" \
    -activebackground $hoverColor

    grid $y.resume -column 0 -row 0 -padx 1m
    grid $y.rename -column 1 -row 0 -padx 1m
    grid $y.ovrwrt -column 2 -row 0 -padx 1m
    grid $y.cancel -column 3 -row 0 -padx 1m

    switch -- $errCode {
	1 {
	    set errMsg ""
	    $y.ovrwrt configure -state disabled
	    $y.resume configure -state disabled
	}
	2 {
	    set errMsg "Local file is smaller than the remote one."
	}
	3 {
	    set errMsg "Local file is bigger than the remote one."
	    $y.resume configure -state disabled
	}
	4 {
	    set errMsg "Local file and the remote one have the same length."
	    $y.resume configure -state disabled
	}
    }
    label $x.msgLabel -text $errMsg -justify center -width 50
    grid $x.msgLabel -row 2 -sticky "ew" -pady 1m

    pack $x $y -side top -pady 1m
    tkwait visibility $w
    grab set $w
}

#******************************
# takes the action selected in
# the queryAction() dialogbox
#
# Args: action ==> action to be taken
#       file ==> file under process
#*****************************
proc takeAction {action {file {}}} {
    variable ftpVars
    catch {grab release .queryActionBox}
    catch {destroy .queryActionBox}

    switch -- $action {
	cancel {
	    set ftpVars(jobDone) 1
	    return
	}
	resume {
	    reget $file
	    return
	}
	rename {
	    variable renDest
	    ask4RenTo $file
	    vwait renDest
	    if {$renDest == ""} {
		return
	    }
	    getNewFile $file $renDest
	    return
	}
	ovrwrt {
	    getNewFile $file $file
	    return
	}
    }
}
    
#***************************************
# Checks if the file exists on the local
# host....if yes then eventually resume it
#
# Args: fileName ==> file to be transferred
#***************************************
proc checkFileExists {fileName fileDescriptor} {
    variable remoteList
    if {[file exists $fileName] == 0} {
	# Ok, the file doesn't exists in the current directory....
	return 0
    } else {
	# Maybe the local file is a directory...
	if {[file isdirectory $fileName] == 1} {
	    return 1
	} else {
	    # Maybe we can try to restart the xfer....localFileSize<remoteFileSize
	    if {[file size $fileName] < $remoteList(fileSize,$fileDescriptor)} {
		return 2
	    } else {
		if {[file size $fileName] > $remoteList(fileSize,$fileDescriptor)} {
		    return 3
		} else {
		    return 4
		}
	    }
	}
    }
}

#*********************************************
# Begins the filetransfer...
#
# Args: fileName ==> remote File..
#********************************************
proc getNewFile {srcFile destFile} {
    # Check if you have write permission on the current directory...
    if {[file writable [pwd]] == 1} {
	get $srcFile $destFile normal
    } else {
	if {[writeLockError 2] == 1} {
	    getNewFile $srcFile $destFile
	    return
	} else {
	    return
	}
    }
}

#**********************************************
# Calculate the time used for the xfer, the
# transfer rate ,etc
#
# Args:
#**********************************************
proc printStatistics {} {
    global ftpInfos
    variable transfer
    variable options
    variable ftpVars

    set elapsedTime [expr ($transfer(stopTime) - $transfer(startTime))]
    set bytes $transfer(bytesXferred)
    if {$elapsedTime != 0} {
	set xferRate [expr (($bytes / $elapsedTime)/1024.0)]
	set cutZone [expr ([string first "." $xferRate] + 2)]
	set xferRate [string range $xferRate 0 $cutZone]
    } else {
	set xferRate "n/a"
    }
    updateLog status "The file was $bytes bytes long, and has been transferred in $elapsedTime seconds with an average rate of $xferRate kbytes/sec"
    # this is a weird place for creating the log entry...but it's a good place
    # because almost all the needed variable are there!!

    if {$options(log) == 1} {
	set logString "[getTime]  "
	if {$ftpVars(lastCmd) == "get"} {
	    set logString "$logString Download ($ftpInfos(ftpServer)): $transfer(remoteFile)->$transfer(localFile)"
	} else {
	    set logString "$logString Upload ($ftpInfos(ftpServer)): $transfer(localFile)->$transfer(localFile)"
	}
	set logString "$logString ($bytes bytes, in $elapsedTime seconds, at $xferRate kbytes/s)"
	addLogEntry [list $logString]
    } 
}
#***********************************************
# Prints an error message indicating that the 
# current directory is write-locked for the
# current user...
#
# Args: 
#***********************************************
proc writeLockError {mode {file {}}} {
    if {$mode == 1} {
	set msg "Error: cannot write to the local target file ($file)..."
    } else {
	set msg "Error: cannot write to the local directory ([pwd])..."
    }
    set button [tk_messageBox -icon error -type retrycancel \
		    -title Error -parent .\
		    -message $msg]

    if {$button == "retry"} {
	return 1
    } else {
	return 0
    }
}

#******************************************
# Prepare the file to be sent to the server
#
# Args: fileName ===> the local file
#*****************************************
proc beginPutProcess {fileName} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	return
    }
    put $fileName
}

#*********************************************
# Prepares for the abort of the current operation
#
# Args:
#*********************************************
proc abortCurrentAction {} {
    abort

    .bottomBttns.abortBttn configure -state disabled
    updateLocalDirList
    # rebind mouse events to the remote list
    unprotectBttns
}
#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#
#               Data connection management....very very hard!!!!
#

#**************************************
# Opens a data connection to the server
# (read the note below for more infos..
#
# Args: 
#**************************************

proc openDataConnection {} {
    variable ftpVars

    # According to the RFC 959, the _SERVER SIDE_ must initiate a Data Transfer
    # (only when we aren't in PASV (passive) mode) to the client side (don't
    # open a Data Connection over the Control Channel!!!): so we need to open
    # a new port on the client side (i.e. create a server socket that accepts
    # connections from the server.) and get the port number, which is going to
    # be sent to the server with the PORT command.

    set ftpVars(tempSocket) [socket -server waitActivityOnDataConn 0]
    set tempDCPort [lindex [fconfigure $ftpVars(tempSocket) -sockname] 2]
    set ftpVars(DCPort) [expr ($tempDCPort / 256)],[expr ($tempDCPort % 256)]

    return
}

#*************************************
# Waits for an activity on the client 
# side of the data connection..
# Attention: the CLIENT side is the 
# server, since we have opened a server
# socket on the local host!!!!!!!!
#
# Args: sock ==> internal Tcl socket
#       address ==> address of the server
#       port ==> port of the server
#
# Note: these arguments are automatically
#       passed by the socket -server 
#       command.
#************************************

proc waitActivityOnDataConn {socket address port} {
    .bottomBttns.abortBttn configure -state normal
    variable ftpVars
    if { $ftpVars(xferMode) == "ascii" } {
	fconfigure $socket -blocking 1 -buffering line
    } else {
	fconfigure $socket -blocking 1 -buffering line -translation binary
    }
    switch $ftpVars(lastCmd) {
	list {
	    set ftpVars(dataSocket) $socket
	    fileevent $socket readable getDirList
	    return
	}
	get {
	    set ftpVars(dataSocket) $socket
	    fileevent $socket readable getFile
	    return
	}
	put {
	    set ftpVars(dataSocket) $socket
	    fileevent $socket writable putFile
	    return
	}
	nlst {
	    set ftpVars(dataSocket) $socket
	    fileevent $socket readable getDirList
	    return
	}
    }

}

#**************************************
# Handles the directory listing coming
# into the data channel.
#
# Args: 
#*************************************
proc getDirList {} {
    variable ftpVars
    variable listBuffer

    .status.statusBar configure -text "Retrieving directory list...."

    while {[eof $ftpVars(dataSocket)]!=1} {
	set listBuffer [read $ftpVars(dataSocket)]
	lappend listing $listBuffer
    }

    .status.statusBar configure -text "Transfer done."

    # Job done, closing data Connection...

    fileevent $ftpVars(dataSocket) readable {}
    close $ftpVars(dataSocket)

    set ftpVars(xferDone) 1

    .bottomBttns.abortBttn configure -state disabled
    updateRemoteDirList $listBuffer
    return
}

#***************************************
# Handles the file coming into the Data
# Connection...
#
# Args:
#***************************************
proc getFile {} {
    variable ftpVars
    variable transfer
    variable handlers

    set ftpVars(xferDone) 0
    set transfer(chunkCount) 0
#    set transfer(segmentStartTime) [getMilliSeconds]
    set transfer(currentXferRate) "n/a"
    set ftpVars(lastBytesXferred) 0

    set transfer(startTime) [clock seconds]
    set transfer(sessionBytes) 0
    if {[info exists transfer(checkPoint)] == 1} {
	set transfer(bytesXferred) $transfer(checkPoint)
    } else {
	set transfer(bytesXferred) 0
    }
    # prevent erratic reading/writing of the data channel
    fileevent $ftpVars(dataSocket) readable {}
    fileevent $ftpVars(dataSocket) writable {}

    # copy from a channel to another one
    fcopy $ftpVars(dataSocket) $handlers(localFile) -command \
	[list xferNextFileFragment] -size $ftpVars(chunk)

}

#******************************************
# Gets the next block of the filetransfer
#
# Args:
#******************************************
proc xferNextFileFragment {bytesXferred {errorStat {}}} {
    variable ftpVars
    variable transfer
    variable handlers

    incr transfer(bytesXferred) $bytesXferred
    incr transfer(sessionBytes) $bytesXferred

    if {([string length $errorStat] != 0) || [eof $ftpVars(dataSocket)]} {

	if {[info exists transfer(checkPoint)] == 1} {
	    set transfer(bytesXferred) [expr $transfer(bytesXferred) - \
					   $transfer(checkPoint)]
	    unset transfer(checkPoint)
	}
	set currentXferRate "n/a"
	.status.statusBar configure -text "File $transfer(curFile) of $transfer(totFiles): Transfer done. (Files left: [expr $transfer(totFiles) - $transfer(curFile)])"

	if {[info exists transfer(idleLoopID)] == 1} {
	    after cancel $transfer(idleLoopID)
	}
	catch {unset transfer(idleLoopID)}
	catch {unset ftpVars(fileIsSymlink)}
	unset transfer(sessionBytes)

	set transfer(stopTime) [clock seconds]
	close $ftpVars(dataSocket)
	close $handlers(localFile)
	.bottomBttns.abortBttn configure -state disabled
	set ftpVars(xferDone) 1
	# avoid some precision problem....
	updatePgBar 100
	# The following if statement is not clear to me...I still don't 
	# understand where the bug is located in the upload functions...
	if {$ftpVars(lastCmd) == "put"} {
	    wait4Completion
	}
	printStatistics
	set ftpVars(jobDone) 1
	if {$ftpVars(lastCmd) == "get"} {
	    updateLocalDirList
	} 
    } else {
	incr transfer(chunkCount)
	if {$transfer(chunkCount) == 2} {
	    set transfer(currentXferRate) [getXferRate]
	}
	if {[info exists ftpVars(fileIsSymlink)] == 0} {
	    set percent [calcPcnt $transfer(bytesXferred) $transfer(fileSize)]
	    updatePgBar $percent
	    set eta [getETA]
	} else {
	    set percent "n/a"
	    set eta "n/a"
	}
	# the next section is used to check if the transfer is stalled...
	# if the throughput is less than 64 bytes/sec (<=> if the timer
	# hasn't been reloaded after 4 seconds...) send out a "xfer stalled"
	# on the status bar...
	if {[info exists transfer(idleLoopID)] == 1} {
	    after cancel $transfer(idleLoopID)
	}
	set transfer(idleLoopID) [after 4000 "warnStalled $percent $transfer(bytesXferred)"]

	.status.statusBar configure -text "File $transfer(curFile) of $transfer(totFiles). Bytes Transferred: $transfer(bytesXferred) @ $transfer(currentXferRate) kbytes/sec ($percent %)    \[ETA: $eta\]"
	fcopy $ftpVars(dataSocket) $handlers(localFile) -command \
	    [list xferNextFileFragment] -size $ftpVars(chunk)
    }
}

#********************************************************
# shows a message indicating that the transfer is stalled
#********************************************************
proc warnStalled {pcnt bytes} {
    variable transfer
    .status.statusBar configure -text "File $transfer(curFile) of $transfer(totFiles). Bytes Transferred: $bytes bytes \[Transfer stalled\] ($pcnt %)    \[ETA: n/a\]"
}
#*******************************************************
# Calculates the ETA (Estimated time of Arrival)
#*****************************************************
proc getETA {} {

    variable transfer

    # checks to see if the current Transfer rate is a number...if not returns
    # "n/a", otherwise....the ETA
    if {$transfer(currentXferRate) == "n/a"} {
	return "n/a"
    }
    set eta_tmp [format "%.0f" [expr ($transfer(fileSize) - $transfer(bytesXferred)) / ($transfer(currentXferRate) * 1024)]]

    if {$eta_tmp >= 0} { 
	set hours [expr ($eta_tmp / 3600)]
	set minutes [expr ($eta_tmp % 3600)]
	set eta [format "%02d:%02d:%02d" $hours [expr ($minutes / 60)] [expr $minutes % 60]]
	return $eta
    } else {
	return "n/a"
    }
}
proc getXferRate {} {
    variable transfer

    set transfer(chunkCount) 0
    set startTime $transfer(startTime)
    set stopTime [clock seconds]
    if {$startTime == $stopTime} {
	return "n/a"
    }
    set bytes $transfer(sessionBytes)
    set xferRate [expr (($bytes/1024.0)/($stopTime-$startTime))]
    set cutZone [expr ([string first "." $xferRate] + 2)]
    set xferRate [string range $xferRate 0 $cutZone]
    return $xferRate
}

proc updatePgBar {percent} {

    global pgBar

    set xPos [expr ($percent/100.0*525.0)]
    $pgBar delete pgStatus

    $pgBar create rectangle 0 0 $xPos 19 -fill orange -stipple gray50 \
	-outline black -tag pgStatus
}

#*****************************
# Sends the file through the 
# data channel
#
# Args:
#********************************
proc putFile {} {
    variable ftpVars
    variable transfer
    variable handlers

    set transfer(chunkCount) 0
    # set transfer(segmentStartTime) [getMilliSeconds]
    set transfer(currentXferRate) "n/a"
    set transfer(startTime) [clock seconds]
    set transfer(bytesXferred) 0
    set transfer(sessionBytes) 0
    # prevent erratic reading/writing of the data channel

    fileevent $ftpVars(dataSocket) readable {}
    fileevent $ftpVars(dataSocket) writable {}

    # Invert the in and out channel (reuse the xferNextFileFragment procedure..
    set temp $ftpVars(dataSocket)
    set ftpVars(dataSocket) $handlers(localFile)
    set handlers(localFile) $temp
    # copy from a channel to another one
    fcopy $ftpVars(dataSocket) $handlers(localFile) -command \
	[list xferNextFileFragment] -size $ftpVars(chunk)
wait4Completion
}

#************************************
# Handles the reget procedure
#
# Args: fileName ===> file to be restored
#************************************
proc reget {fileName} {
    variable transfer

    set restartPoint [file size $fileName]
    set transfer(checkPoint) $restartPoint

    get $fileName $fileName resume $restartPoint
    
}

proc remoteEntryBoxUpdate {dir} {
    set entryCnt [.fileListBoxes.remoteEntry get]
    switch -- $dir {
	"." {
	    return
	}
	".." {
	    set slash [string last "/" $entryCnt]
	}
    }
}

#@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
#
#          F T P  commands management
#

#*************************************
# Sends a list command to the server
#
# Args: dir ==> directory to be listed
#*************************************
proc rlist {{dir ""}} {
    variable ftpVars
    variable directories

    if {$ftpVars(connected) == 0} {
	updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
	return
    }

    if {$dir == ""} {
	set dir ./
    }

    set directories(remoteCWD) $dir
    # change the date type
    type ascii
    # wait the change take effect (==> the server answers us)
    wait4Completion
    set ftpVars(cmdStatus) list
    # begin the negotiation phase: open a socket, etc
    ftpHandler
    updateLog cIOSend "LIST"
    ftpHandler
    set ftpVars(lastCmd) list
}

#**************************************
# Sets the transfer mode (ASCII or binary)
#
# Args: mode ==> transfer mode
#**************************************
proc type {mode} {
    variable ftpVars

    if {$mode == "ascii"} {
	set xferMode A
    } else {
	set xferMode I
    }
    set ftpVars(xferMode) $xferMode
    updateLog cIOSend "TYPE $xferMode"

    set ftpVars(lastCmd) type
    set ftpVars(cmdStatus) type

    ftpHandler

    return
}

#*****************************************
# Changes the Current Working Directory 
# (CWD).
#
# Args: dir ==> the remote dir to be 
#               changed
#**************************************
proc lcwd {dir} {

    variable ftpVars
    variable directories

    # checks if ftpVars(listOK) is there...this is used by trySymlink() to
    # determine if the symlink is a file or a directory...

    if {[info exists ftpVars(listOK)] != 1} {
	set ftpVars(listOK) 0
    }

    updateLog cIOSend "CWD $dir"

    set directories(remoteCWD) $dir
    set ftpVars(lastCmd) cwd
    set ftpVars(cmdStatus) cwd

    ftpHandler

    wait4Completion

    remoteEntryBoxUpdate $dir
    rpwd

    if {$ftpVars(listOK) == 1} {
	set ftpVars(listOK) 0
	return 1
    } else {
	return -1
    }
}

#*****************************************
# Gets the Current Working Directory 
#
#**************************************

proc rpwd {} {
    variable ftpVars

    updateLog cIOSend "PWD"

    set ftpVars(lastCmd) pwd
    set ftpVars(cmdStatus) pwd

    ftpHandler

    wait4Completion

    return
}

#***************************************
# get a new file
#
# Args: fileName ==> file to be transferred
#***************************************
proc get {srcFile destFile retrMode {checkPoint {}}} {
    variable ftpVars
    variable handlers
    variable transfer

    set transfer(remoteFile) $srcFile
    set transfer(localFile) $destFile
    set transfer(retrMode) $retrMode

    # Open a file in write-mode
    if {$transfer(retrMode) == "normal"} {
	set handlers(localFile) [open $destFile w]
    } else {
	set handlers(localFile) [open $destFile a]
    }

    fconfigure $handlers(localFile) -blocking 1 -buffering line -translation binary

    type binary
    wait4Completion
    set ftpVars(cmdStatus) retr
    ftpHandler

    set ftpVars(lastCmd) get
    ftpHandler
    wait4Completion
}

#********************************************
# Abort core...ahem....doesn't work @ the moment....
#
# Update: this is a temporary solution until I find
#         something better....
# Args:
#********************************************
proc abort {} {
    variable ftpVars
    variable handlers
    if {$ftpVars(lastCmd) == "put"} {
	catch {close $handlers(localFile)}
	catch {close $ftpVars(dataSocket)}
	updateLog status "Transfer aborted...."
	return
    }
    # these variables are used for the telnet's style control sequences
    set IAC 255
    set IP  244
    set DM  242
    set AO  245

    updateLog cIOSend "ABOR"

    # Well, I'm using the method described in the RFC 959 for aborting a
    # transfer: I have to use the telnet's IP-SYNCH sequence!!

    # First of all, we need to set the control channel on binary mode, since
    # all the control sequences are sent as 8bit data, directly embedded in
    # the data stream. We also disable the buffering....only to be sure...

    fconfigure $handlers(ctrlIO) -translation {auto binary} -buffering none -blocking 1

    # Then we send the IAC (Interpret As Command), directly followed with a 
    # IP (Interrupt Proccess). Note that we don't send any new-line characters:
    # the control stream shouldn't be interrupted with any trailing chars.
    # Overriding the sendToCtrlChannel() procedure.....

    puts -nonewline $handlers(ctrlIO) [format %c%c $IAC $IP]
    puts -nonewline $handlers(ctrlIO) [format %c%cABOR\r\n $IAC $DM]
    flush $handlers(ctrlIO)

    set ftpVars(cmdStatus) abor
    ftpHandler

#    set ftpVars(lastCmd) abor
# temporarily out of order...next time activate the wait loop!
#    wait4Completion

    # ok we can close all the data channels....
    catch {close $handlers(localFile)}
    catch {close $ftpVars(dataSocket)}
    # and revert to the normal control channel (without the binary translations
    # and the buffering disabled...)
    fconfigure $handlers(ctrlIO) -translation {auto crlf} -buffering line -blocking 1

    updateLog status "Transfer aborted...."
}

#*********************************
# Sends the username to the server
#
#*********************************
proc user {} {

    variable ftpVars
    variable ftpInfos

     if {$ftpInfos(userName) == ""} {
        queryInfo user
	wait4Completion
    }

    updateLog cIOSend "USER $ftpInfos(userName)"

    set ftpVars(cmdStatus) user
    set ftpVars(lastCmd) user
    ftpHandler
    wait4Completion
    if {$ftpVars(cmdStatus) != "user_failed"} {
	pass
    } else {
	updateLog error "Unable to login....aborting."
	# close directly the control connection...
	catch {close $handlers(ctrlIO)}
	set ftpVars(connected) 0
    }
}

#*********************************
# Sends the password to the server
#
# Args: password ===> trivial isn't it?
#*********************************
proc pass {} {
    variable ftpVars
    variable ftpInfos

    set ftpVars(lastCmd) pass
    set ftpVars(cmdStatus) pass

    if {$ftpInfos(password) == ""} {
	queryInfo pass
	wait4Completion
    }
    updateLog cIOSend "PASS ******"
    ftpHandler
    wait4Completion
    if {$ftpVars(cmdStatus) == "pass_failed"} {
	quit
    }
}

#***********************************
# Close the current connection
#
# Args:
#***********************************
proc quit {} {
    variable ftpVars
    variable handlers

    updateLog cIOSend "QUIT"

    set ftpVars(lastCmd) quit
    set ftpVars(cmdStatus) quit

    ftpHandler

    wait4Completion

    catch {close $ftpVars(dataSocket)}
    catch {close $handlers(ctrlIO)}

    cleanVars
    set ftpVars(connected) 0
}

#************************************
# Sends a PORT command to the server
#
# Args: 
#************************************
proc port {} {
    variable ftpVars

    updateLog cIOSend "PORT $ftpVars(localIP),$ftpVars(DCPort)"

    set ftpVars(lastCmd) port
    set ftpVars(cmdStatus) port

    ftpHandler

    return
}

#************************************
# Puts a file on the server
#
# Args: fileName ===> the file to be
#                     transferred
#************************************
proc put {fileName} {
    variable ftpVars
    variable transfer
    variable handlers

    # Open a file in write-mode

    set transfer(fileSize) [file size $fileName]
    set transfer(localFile) $fileName

    set handlers(localFile) [open $fileName r]

    fconfigure $handlers(localFile) -blocking 1 -buffering line -translation binary

    type binary
    wait4Completion
    set ftpVars(cmdStatus) stor
    ftpHandler

    set ftpVars(lastCmd) put
    ftpHandler
    wait4Completion
}

#***********************************
# Sends a REST request to the server
# Useful for tranfer restore...
#
# Args: checkPoint ===> restart point
#***********************************
proc rest {checkPoint} {
    variable ftpVars

    updateLog cIOSend "REST $checkPoint"

    # Well...this is not really correct...I have to modify a little bit the
    # core...
    set ftpVars(lastCmd) get
    set ftpVars(cmdStatus) rest

    ftpHandler
#    wait4Completion
}

#***********************************
# Sends a NLST command to the server
# for getting the short filelist
#***********************************
proc nlst {{dir ""}} {
    variable ftpVars
    variable errors

    if {$dir == ""} {
	set dir ./
    }

    type ascii


    openDataConnection

    updateLog cIOSend "NLST $dir"

    set ftpVars(lastCmd) nlst
    set ftpVars(cmdStatus) nlstSent

    sendToCtrlChannel "NLST $dir"

    wait4Completion

    return 0
}

#*******************************
# Query the status of the server
#******************************
proc stat {} {
    variable ftpVars

    updateLog cIOSend "STAT"

    set ftpVars(lastCmd) stat
    set ftpVars(cmdStatus) stat

    ftpHandler

    wait4Completion
}

#**************************
# Makes a new directory on
# the server
#**************************
proc mkdir {newDir} {
    variable ftpVars
    variable directories

    updateLog cIOSend "MKD $newDir"

    set ftpVars(lastCmd) mkd
    set ftpVars(cmdStatus) mkd
    set directories(mkd) $newDir

    ftpHandler

    wait4Completion
}

#*******************************************
# Gets the OS of the remote host
#
# Args:
#*******************************************
proc getSysType {} {
    variable ftpVars

    updateLog cIOSend "SYST"

    set ftpVars(lastCmd) syst
    set ftpVars(cmdStatus) syst

    ftpHandler

    wait4Completion
}

#*******************************************
# Deletes a file on the remote host
#
# Args: target ==> file to be deleted
#*******************************************
proc dele {target} {
    variable ftpVars
    variable dele_target

    updateLog cIOSend "DELE $target"

    set ftpVars(lastCmd) dele
    set ftpVars(cmdStatus) dele
    set dele_target $target

    ftpHandler

    wait4Completion
}

#*******************************************
# Deletes a directory on the remote host
#
# Args: target ==> directory to be deleted
#*******************************************
proc rmd {target} {
    variable ftpVars
    variable directories

    updateLog cIOSend "RMD $target"

    set ftpVars(lastCmd) rmd
    set ftpVars(cmdStatus) rmd
    set directories(rmd) $target

    ftpHandler

    wait4Completion
}

#*******************************************
# Rename a file on the server (part I)
#
# Args: target ==> file to be renamed
#*******************************************
proc rnfr {target} {
    variable ftpVars
    variable rename

    updateLog cIOSend "RNFR $target"

    set ftpVars(lastCmd) rnfr
    set ftpVars(cmdStatus) rnfr
    set rename(target) $target

    ftpHandler

    wait4Completion
}

#*******************************************
# Rename a file on the server (part II)
#
# Args: target ==> destination name
#*******************************************
proc rnto {target} {
    variable ftpVars
    variable rename

    updateLog cIOSend "RNTO $target"

    set ftpVars(lastCmd) rnto
    set ftpVars(cmdStatus) rnto
    set rename(newTarget) $target

    ftpHandler

    wait4Completion
}
#***************************
#---------------------------
#Local Files Management
#---------------------------
#***************************

#***********************
# Creates a new Dir.
#
# Args:
#***********************
proc lMkdir {} {
    global newDir
    #check the if the local dir can be written
    if {[file writable [pwd]] == 1} {
	askDirName
	vwait newDir
	if {$newDir == ""} {
	    return
	}
	catch {[file mkdir $newDir] answ}
	if {[info exists answ] == 0} {
	    updateLog status "The directory $newDir has been successfully created!" 
	    updateLocalDirList
	    return
	}
    } else {
	if {[writeLockError 2] == 1} {
	    lMkdir
	    return
	} else {
	    updateLog error "Unable to make a new directory: cannot write on this directory ([pwd]). Check the write-permissions."
	    return
	}
    }
}

#***************************
# A dialog box for querying
# a directory name
#
# Args:$newDir
#***************************
proc askDirName {} {
    global hoverColor
    toplevel .dirQuery
    catch {.dirQuery destroy}
    wm resizable .dirQuery 0 0
    wm title .dirQuery "Create a new directory"
    frame .dirQuery.info
    label .dirQuery.info.infoLabel -text "Enter the new directory name : "
    entry .dirQuery.info.entry -width 27

    grid .dirQuery.info.infoLabel .dirQuery.info.entry -pady 1m -sticky "we"

    frame .dirQuery.bttns
    button .dirQuery.bttns.ok -text "ok" -command "getDirName 1" \
	-activebackground $hoverColor
    button .dirQuery.bttns.cancel -text "cancel" -command "getDirName 0" \
	-activebackground $hoverColor

    grid .dirQuery.bttns.ok .dirQuery.bttns.cancel -padx 1m

    focus .dirQuery.info.entry
    bind .dirQuery.info.entry <Return> "getDirName 1"
    pack .dirQuery.info .dirQuery.bttns -side top -pady 1m
    tkwait visibility .dirQuery
    grab set .dirQuery
}

#**********************************
# Get the new dirname and return it
#
# Args:
#**********************************
proc getDirName {retMode} {
    global newDir
    if {$retMode == 1} {
	set newDir [.dirQuery.info.entry get]
    } else {
	set newDir ""
    }
    destroyWin dirQuery
    return
}

#*************************
# destroy the box querying for
# the directory's name
#*************************
proc destroyWin {winID} {
    catch {grab release .$winID}
    catch {destroy .$winID}
    return
}

#***************************
# Deletes a the selected
# directory
#
# Args: 
#**************************
proc lRmdir {} {
    global filesName

    set curSelection [.fileListBoxes.localList.list curselection]
    if {$curSelection == ""} {
	return
    }
    incr curSelection
    set curSelection $filesName($curSelection)
    if {[file isdirectory $curSelection] ==0} {
	tk_messageBox -icon error -type ok \
	    -title Error! -parent . \
	    -message "Error: the current selection is a file. Please select a directory."
	return
    }

    set fileList ""
    cd $curSelection
    foreach i [lsort [glob -nocomplain [file join [pwd] *]]] {
	lappend fileList $i
    }
    if {[llength $fileList] != 0} {
	tk_messageBox -icon error -type ok \
	    -title Error! -parent . \
	    -message "Error: the directory you have selected isn't empty. Please empty it and retry."
	cd ..
	return
    }

    set answ [tk_messageBox -icon question -type yesno -title "Confirmation" -parent . \
		  -message "Are you sure that you want to delete the selected directory ([pwd])?"]
    cd ..
    if {$answ == "no"} {
	return
    }
    file delete $curSelection
    updateLog status "The selected directory has been successfully removed"
    updateLocalDirList
    return
}

#**************************
# Deletes the selected file
#**************************
proc lRm {} {
    global filesName

    set delCount 0

    set selFiles [.fileListBoxes.localList.list curselection]
    if {$selFiles == ""} {
	return
    }
    foreach i $selFiles {
	incr i
	set curSelection $filesName($i)
	
	if {[file isdirectory $curSelection] == 1} {
	    tk_messageBox -icon error -type ok \
		-title Error! -parent . \
		-message "Error: $curSelection is a directory. Please select only files."
	    continue
	}
	if {[file writable $curSelection] != 1} {
	    tk_messageBox -icon error -type ok \
		-title Error! -parent . \
		-message "Error: you haven't write permissions on the selected file ($curSelection). Cannot delete."
	    continue
	}
	set answ [tk_messageBox -icon question -type yesno -title "Confirmation" -parent . \
		      -message "Are you sure that you want to delete the selected file ($curSelection)?"]
	if {$answ == "no"} {
	    continue
	}
	incr delCount
	file delete $curSelection
    }
    if {$delCount > 0} {
	updateLog status "The selected files have been successfully removed"
    }
    updateLocalDirList
    return
}

#*********************
# Renames a file or a 
# directory
#*********************
proc lRen {} {
    global filesName
    global renDest

    set curSelection [.fileListBoxes.localList.list curselection]
    if {$curSelection == ""} {
	return
    }
    if {[llength $curSelection] > 1} {
	tk_messageBox -icon error -type ok -title Error -parent . \
	    -message "Please select only one file for renaming!"
	return
    }
    incr curSelection
    set curSelection $filesName($curSelection)

    ask4RenTo $curSelection
    vwait renDest
    if {$renDest == ""} {
	return
    }
    # check if the dest already exists
    if {[file exists $renDest] == 1} {
	tk_messageBox -icon error -type ok \
	    -title Error -parent .\
	    -message "Error: the destination name you've chosen ($renDest) already exists in this directory..."
    return
    }

    # check if you've the write access on this file...    
    if {[file writable $curSelection] != 1} {
	tk_messageBox -icon error -type ok \
	    -title Error -parent .\
	    -message "Error: cannot write to the selected file: check file permissions..."
	return
    }

    catch {[file rename $curSelection $renDest] answ}
    if {[info exists answ] == 0} {
	updateLog status "The file (or directory) $curSelection has been successfully renamed to $renDest!" 
	updateLocalDirList
	return
    }
}

#****************************
# Draws the dialog box querying
# the destination name of the ren
#****************************
proc ask4RenTo {origName} {
    global hoverColor
    toplevel .renQuery
    catch {.renQuery destroy}
    wm resizable .renQuery 0 0
    wm title .renQuery "Rename $origName to"
    frame .renQuery.info
    label .renQuery.info.infoLabel -text "Rename the file in:"
    entry .renQuery.info.entry -width 29
    grid .renQuery.info.infoLabel .renQuery.info.entry -pady 1m

    frame .renQuery.bttns
    button .renQuery.bttns.ok -text "ok" -command "getRenToName 1" \
	-activebackground $hoverColor
    button .renQuery.bttns.cancel -text "cancel" -command "getRenToName 0" \
	-activebackground $hoverColor
    grid .renQuery.bttns.ok .renQuery.bttns.cancel -padx 1m

    bind .renQuery.info.entry <Return> "getRenToName 1"
    focus .renQuery.info.entry
    pack .renQuery.info .renQuery.bttns -side top -pady 1m
    tkwait visibility .renQuery
    grab set .renQuery
}

#**********************************
# Extract the destination name
# for the rename
#**********************************
proc getRenToName {retMode} {
    global renDest

    if {$retMode == 1} {
	set renDest [.renQuery.info.entry get]
    } else {
	set renDest ""
    }
    destroyWin renQuery
}

#***************************
#---------------------------
# Remote Files Management
#---------------------------
#***************************

#***********************
# Creates a new Dir.
#
# Args:
#***********************
proc rMkdir {} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
	return
    }
    global newDir
    askDirName
    vwait newDir
    if {$newDir == ""} {
	return
    }

    mkdir $newDir

    if {$ftpVars(cmdStatus) == "mkd_done"} {
	rlist
    }
}

proc rRmdir {} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
	return
    }

    set curSelection [.fileListBoxes.remoteList.list curselection]
    if {$curSelection == ""} {
	return
    }
    incr curSelection

    variable remoteList

    set target $remoteList(nameList,$curSelection)
    if {($target==".") || ($target=="..")} {
	updateLog error "Cannot delete \"$target\""
	return
    }
    set answ [tk_messageBox -icon question -type yesno -title "Confirmation" -parent . \
		  -message "Are you sure that you want to delete the selected directory ($target)?"]
    if {$answ == "no"} {
	return
    }

    rmd $target

    if {$ftpVars(cmdStatus) == "rmd_done"} {
	rlist
    }
}

#******************************
# Deletes a file on the server
#*****************************
proc rRm {} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
	return
    }

    set selFiles [.fileListBoxes.remoteList.list curselection]
    if {$selFiles == ""} {
	return
    }

    foreach curSelection $selFiles {
	incr curSelection
	
	variable remoteList
	
	set target $remoteList(nameList,$curSelection)
	if {($target==".") || ($target=="..")} {
	    updateLog error "Cannot delete \"$target\""
	    return
	}
	set answ [tk_messageBox -icon question -type yesno -title "Confirmation" -parent . \
		      -message "Are you sure that you want to delete the selected file ($target)?"]
	if {$answ == "no"} {
	    return
	}
	
	dele $target
    }
    rlist
}
#********************************
# Renames a file or a  directory
#********************************
proc rRen {} {
    variable ftpVars

    if {$ftpVars(connected) == 0} {
	updateLog error "Not connected: please use the \"Connect\" button to connect to the FTP server"
	return
    }

    set curSelection [.fileListBoxes.remoteList.list curselection]
    if {$curSelection == ""} {
	return
    }
    if {[llength $curSelection] > 1} {
	tk_messageBox -icon error -type ok -title Error -parent . \
	    -message "Please select only one file for renaming!"
	return
    }
    incr curSelection

    variable remoteList

    set target $remoteList(nameList,$curSelection)
    if {($target==".") || ($target=="..")} {
	updateLog error "Cannot rename \"$target\""
	return
    }

    variable renDest
    ask4RenTo $target
    vwait renDest
    if {$renDest == ""} {
	return
    }
    rnfr $target
    if {$ftpVars(cmdStatus) == "rnfr_done"} {
	rnto $renDest
    } else {
	return
    }

    if {$ftpVars(cmdStatus) == "rnto_done"} {
	rlist
    }
}

#************************************
# Enters in a wait-loop, waiting the
# commands sent to the server have
# been completed
#************************************
proc wait4Completion {} {
    variable ftpVars

    vwait ftpVars(jobDone)

    set ftpVars(jobDone) 0

    return
}

proc about {} {
    global appInfo graphic_about imAbout_x imAbout_y tcl_platform hoverColor
 
    set w .about
    toplevel $w
    wm title $w "tkFTP About"
    wm geometry $w =230x250
    wm resizable $w 0 0


# that's the title with the old logo
#    label $w.title -text "tkFTP" -justify center -width 25 -foreground blue
#    pack $w.title -pady 5

    canvas $w.c -height $imAbout_y -width $imAbout_x
    $w.c create image [expr $imAbout_x / 2] [expr $imAbout_y / 2] \
	-image [image create photo -file $graphic_about]
    pack $w.c -pady 5
    label $w.text1 -text "This is version $appInfo(majorVer).$appInfo(minorVer).$appInfo(revLevel) of tkFTP" -justify center
    pack $w.text1
    label $w.copyright -text "Copyright (c) 1998-1999\n\n Pascal Jermini\n<redoctober@bluewin.ch>\n\n Firebird\n<firebird@chez.com>"
    pack $w.copyright

    # Show some system Informations...
    set sysInfoString "($tcl_platform(os) $tcl_platform(osVersion) running on a $tcl_platform(machine))"
    label $w.sysInfo -text $sysInfoString -justify center -width 60
    pack $w.sysInfo

    button $w.okBttn -text "Ok" -command "destroyAbout $w" \
	-activebackground $hoverColor
    pack $w.okBttn -pady 10
    
    tkwait visibility $w
    grab set $w
    
}

proc destroyAbout {win} {

    catch {grab release $win}
    catch {destroy $win}
}

proc calcPcnt {a b} {

    set a [append a .0]
    set b [append b .0]
    set pcnt [expr ($a/$b)*100]
    set cutZone [expr ([string first "." $pcnt] + 2)]
    set pcnt [string range $pcnt 0 $cutZone]
    return $pcnt
}


proc  getRPwd {string} {

    set firstQuote [expr ([string first "\"" $string]+1)]
    set string [string range $string $firstQuote end]
    set firstQuote [expr ([string first "\"" $string]-1)]
    set string [string range $string 0 $firstQuote]

    .fileListBoxes.remoteEntry delete 0 end
    # check if we are on the root directory...if yes don't add an extra slash.
    if {$string == "/"} {
	.fileListBoxes.remoteEntry insert 0 $string
    } else {
	.fileListBoxes.remoteEntry insert 0 "$string/"
    }
}

#*****************************
# Configuration panel -Begin-
#*****************************

proc confPanelInit {} {
    global confPanelHandler imConfig_y
    set confPanelHandler .confPanel
    set x $confPanelHandler

    catch {destroy $x}
    toplevel $x
    wm title $x "Configuration"
    wm iconname $x "Configuration"
    wm resizable $x 0 0

    createConfBanner
    cp_setLayout
    cp_readConfig

    tkwait visibility $x
    raise $x
    grab set $x
}

proc createConfBanner {} {
    global imConfig_x imConfig_y graphic_config
    set imConfig_x1 [expr ($imConfig_x-10)]
    set imConfig_y1 [expr ($imConfig_y-10)]

    label .confPanel.confBan -width 325
    pack .confPanel.confBan -side top
    canvas .confPanel.confBan.c -height $imConfig_y1 -width $imConfig_x1
    .confPanel.confBan.c create image [expr $imConfig_x1 / 2] [expr $imConfig_y1 / 2] -image [image create photo -file $graphic_config]
    pack .confPanel.confBan.c -side top
}

proc cp_setLayout {} {

    global confPanelHandler logXfers imConfig_y hoverColor

    set x $confPanelHandler
    frame $x.bttns
    frame $x.email
    frame $x.logXfers
    frame $x.logFile
    frame $x.logSize

    # Buttons at the bottom
    button $x.bttns.okBttn -text "Ok" -command "cp_done" \
	-activebackground $hoverColor
    button $x.bttns.cancBttn -text "Cancel" -command "cp_abort" \
	-activebackground $hoverColor

    grid $x.bttns.okBttn -column 0 -row 0 -padx 2m -pady 1m
    grid $x.bttns.cancBttn -column 1 -row 0 -padx 2m -pady 1m

    # Default E-mail (for  anonymous logins)
    label $x.email.defEMailLab -text "Default E-Mail for \nanonymous Logins:"
    entry $x.email.defEMailEntry -width 25

    grid $x.email.defEMailLab -column 0 -row 0 -pady 1m
    grid $x.email.defEMailEntry -column 1 -row 0 -pady 1m

    # Log transfers?
    checkbutton $x.logFile.log -variable logXfers -offvalue No -onvalue Yes \
	-text "Log Transfers?" -command "cp_logStatus"    

    # Log file...
    label $x.logFile.logFileLab -text "Log directory (if \nnone specified: \"~/\"):"
    entry $x.logFile.logFileEntry -width 25

    grid $x.logFile.log -column 0 -row 0 -pady 1m
    grid $x.logFile.logFileLab -column 0 -row 1 -pady 1m
    grid $x.logFile.logFileEntry -column 1 -row 1 -pady 1m

    # Max log size....should be useful for those who are lacking disk space
    # like me ;-)
    label $x.logSize.logSizeLab -text "Maximum log file size \n(0 = unlimited)"
    entry $x.logSize.logSizeEntry -width 10
    label $x.logSize.logSizeByte -text "bytes"

    grid $x.logSize.logSizeLab -column 0 -row 0 -pady 1m
    grid $x.logSize.logSizeEntry -column 1 -row 0 -pady 1m
    grid $x.logSize.logSizeByte -column 2 -row 0 -pady 1m

    pack $x.email
    pack $x.logFile
    pack $x.logSize
    pack $x.bttns -ipady 1m

}

proc cp_logStatus {} {

    global confPanelHandler logXfers tkstepOptimized

    set x $confPanelHandler

    if {[string toupper $logXfers] == "YES"} {
	$x.logFile.logFileLab configure -foreground black
	$x.logFile.logFileEntry configure -state normal
	$x.logSize.logSizeLab configure -foreground black
	$x.logSize.logSizeEntry configure -state normal
	$x.logSize.logSizeByte configure -foreground black
	return
    }
    if {$tkstepOptimized == 0} {
	set fgCol darkgrey
    } else {
	set fgCol grey30
    }
    $x.logFile.logFileLab configure -foreground $fgCol
    $x.logSize.logSizeLab configure -foreground $fgCol
    $x.logSize.logSizeByte configure -foreground $fgCol

    $x.logFile.logFileEntry configure -state disabled
    $x.logSize.logSizeEntry configure -state disabled
}

proc cp_abort {} {

    global confPanelHandler

    set x $confPanelHandler

    closeRCFile
    # re-read the configuration file, so the changes are taken in account...
    readUserOptions
    catch {grab release $x}
    catch {destroy $x}
}

proc cp_readConfig {} {

    global confPanelHandler

    set x $confPanelHandler

    openRCFile

    # OK, we can get the default password...
    set reply [scanFile "DefaultEMail" retOnFirstMatch]
    if {$reply != 0} {
	regsub "DefaultEMail=" $reply "" reply
	$x.email.defEMailEntry delete 0 end
	$x.email.defEMailEntry insert 0 $reply
    }

    # OK, now we can get the Logging option...
    set reply [scanFile "LogXFers" retOnFirstMatch]
    # if returns 0, then the string has not been found...
    if {$reply == 0} {
	$x.logFile.log deselect
	cp_logStatus
    } else {
	# the key has been found...now shall we log???
	regsub "LogXFers=" $reply "" reply
	if {[string toupper $reply] == "YES"} {
	    $x.logFile.log select
	} else {
	    $x.logFile.log deselect
	}
    }
    # ok now we can try to search for the path of the logfile...
    set reply [scanFile "LogPath" retOnFirstMatch]
    if {$reply != 0} {
	# the key has been found...where shall we log???
	regsub "LogPath=" $reply "" reply
	# check for the validity of the path...
	if {[file isfile $reply] == 1} {
	    set button [tk_messageBox -icon error -type ok \
			    -title Error -parent $x\
			    -message "Configuration error: \"$reply\" is not a valid directory for logging, but a regular file. Please use a directory. Using ~/ as logging directory."]
	    set reply "~/"
	} elseif {[file isdirectory $reply] == 0} {
	    set button [tk_messageBox -icon error -type ok \
			    -title Error -parent $x\
			    -message "Configuration error: \"$reply\" is not a valid directory for logging. Using ~/ as logging directory."]
	    set reply "~/"
	} elseif {[file writable $reply] == 0} {
	    set button [tk_messageBox -icon error -type ok \
			    -title Error -parent $x\
			    -message "Configuration error: \"$reply\" is not a writable directory for logging. Using ~/ as logging directory."]
	    set reply "~/"
	}
	$x.logFile.logFileEntry delete 0 end
	$x.logFile.logFileEntry insert 0 $reply
    }
    # very well, next item? the maximum log size (if not specified: maxSize=0)
    set reply [scanFile "LogMaxSize" retOnFirstMatch]
    if {$reply != 0} {
	# the key has been found...now extract the size
	regsub "LogMaxSize=" $reply "" reply
	# check for non-numerical sizes
	if {[regexp -- \[^0-9\] $reply] == 1} {
	    tk_messageBox -icon error -type ok \
		-title Error -parent $x\
		-message "Configuration error: $logSize is not a valid number for the maximum log size! Using unlimited log size."
	    set reply 0
	}
	$x.logSize.logSizeEntry delete 0 end
	$x.logSize.logSizeEntry insert 0 $reply
    } else {
	$x.logSize.logSizeEntry delete 0 end
	# use 0 if not specified
	$x.logSize.logSizeEntry insert 0 0
    }
    cp_logStatus
}

proc cp_done {} {

    cp_saveConfig
    cp_abort
}

proc cp_saveConfig {} {

    global confPanelHandler logXfers
    variable fileHandlers

    set x $confPanelHandler

    # gather the informations from the widgets..
    set defEMail [$x.email.defEMailEntry get]
    set logPath [$x.logFile.logFileEntry get]
    set logSize [$x.logSize.logSizeEntry get]
    
    # check if the size was provided...(if not, assume logSize=0)
    if {[string length $logSize ] == 0} {
	set logSize 0
    }
    # Now check if the input was only numbers...using regexp...
    if {[regexp -- \[^0-9\] $logSize] == 1} {
	tk_messageBox -icon error -type ok \
	    -title Error -parent $x\
	    -message "Error: $logSize is not a number! Using 0 (unlimited) as maximum size."
	set logSize 0
    }

    if {$logPath == ""} {
	set logPath "~/"
    }
    if {[file isfile $logPath] == 1} {
	set button [tk_messageBox -icon error -type ok \
			-title Error -parent $x\
			-message "Error: $logPath is not a directory but a regular file! Using ~/ as logging directory."]
	set logPath "~/"
    } elseif {[file isdirectory $logPath] == 0} {
	set button [tk_messageBox -icon error -type ok \
			-title Error -parent $x\
			-message "Error: $logPath is not a directory! Using ~/ as logging directory."]
	set logPath "~/"
    } elseif {[file writable $logPath] == 0} {
	set button [tk_messageBox -icon error -type ok \
			-title Error -parent $x\
			-message "Error: $logPath is not a writable directory! Using ~/ as logging directory."]
	set logPath "~/"
    }

    seek $fileHandlers(rcFile) 0 start
    set wholeRC [getWholeFile rcFile]
    
    # open a new RC file...
    set fileHandlers(newrcFile) [open ~/.tkFTPrc.new w]
    fconfigure $fileHandlers(newrcFile) -buffering none

    # Put the settings at the beginning, before the profiles...
    puts $fileHandlers(newrcFile) "DefaultEMail=$defEMail"
    puts $fileHandlers(newrcFile) "LogXFers=$logXfers"
    puts $fileHandlers(newrcFile) "LogPath=$logPath"
    puts $fileHandlers(newrcFile) "LogMaxSize=$logSize"

    # add the profile settings...
    for {set i 0} {$i<[expr [llength $wholeRC]-1]} {incr i} {
	set workingOn [string trim [lindex $wholeRC $i]]
	if {([regexp -- "DefaultEMail=" $workingOn] == 0) && ([regexp -- "LogXFers=" $workingOn] == 0) && ([regexp -- "LogPath=" $workingOn] == 0) && ([regexp -- "LogMaxSize=" $workingOn] == 0)} {

	    puts $fileHandlers(newrcFile) $workingOn
	}
    }
    # copy the new RC file...and delete the old one
    close $fileHandlers(newrcFile)

    file copy -force -- "~/.tkFTPrc.new" "~/.tkFTPrc"
    file delete "~/.tkFTPrc.new"
}
#*****************************
# Configuration panel -End-
#*****************************

#*******************************
# Opens the log file...
#*******************************
proc openLogFile {} {

    variable fileHandlers
    variable options
   
    set logFile "$options(logDir)/tkFTP.log"
    # check if the file exists and if the file size has not exceeded the 
    # maximum size allowed....if either of these affermation are false...
    # create a new file...
    if {[file exists $logFile] != 1} {
	createNewLog $logFile
    }
    if {$options(logSize) !=0} {
	if {[file size $logFile] > $options(logSize)} {
	    file delete $logFile
	    createNewLog $logFile
	}
    }

    # And now open it again, in write-only+append mode...
    set fileHandlers(logFile) [open $logFile a]
    fconfigure $fileHandlers(logFile) -buffering none
}

#*************************
# Self-explanatory....
#*************************
proc createNewLog {logFile} {

    # we only have to open and reclose it if it doesn't exist...
    # plus, add a little header...
    set tmpFH [open $logFile w]
    fconfigure $tmpFH -buffering none
	puts $tmpFH "\#*** Log File for tkFTP, created on [getTime] ***"
    # ok close it now...
    flush $tmpFH
    close $tmpFH
}
#*****************************
# Adds an entry to the log
#*****************************
proc addLogEntry {logString} {

    variable fileHandlers

    puts $fileHandlers(logFile) [lrange $logString 0 end]
    flush $fileHandlers(logFile)
}

#******************************
# Closes the log file...
#******************************
proc closeLogFile {} {

    variable fileHandlers

    # flush the buffer...
    flush $fileHandlers(logFile)
    # close the log...
    close $fileHandlers(logFile)
}

#***************************************
# Returns the time of the day
# using month day year hh:mm:ss notation
#****************************************
proc getTime {} {
    return [clock format [clock seconds] -format "%b %d %Y %H:%M:%S"]
}

#*****************************************
# Queries the user for the password.
#*****************************************
proc queryInfo {mode} {
    variable ftpInfos 
    global hoverColor
    
    toplevel .queryInfo
    frame .queryInfo.label
    frame .queryInfo.entry
    frame .queryInfo.bttn

    catch {.queryInfo destroy}

    wm resizable .queryInfo 0 0
    label .queryInfo.label.infoLabel -text "xxx"
    grid .queryInfo.label.infoLabel -sticky "w" -padx 1c -pady 1m
    entry .queryInfo.entry.entry -width 30
    pack  .queryInfo.entry.entry
    button .queryInfo.bttn.ok -text "ok" -command "setInputFromQuery $mode" \
	-activebackground $hoverColor
    grid .queryInfo.bttn.ok -pady 3m

    pack .queryInfo.label
    pack .queryInfo.entry
    pack .queryInfo.bttn

    if {$mode == "pass"} {
        .queryInfo.entry.entry configure -show *
        .queryInfo.label.infoLabel configure -text "Enter the password for $ftpInfos(userName)@$ftpInfos(ftpServer): "
        wm title .queryInfo "Enter Password"
    } else {
        .queryInfo.label.infoLabel configure -text "Enter the username for the server $ftpInfos(ftpServer): "
	wm title .queryInfo "Enter Username"
    }

    focus .queryInfo.entry.entry
    bind .queryInfo.entry.entry <Return> "setInputFromQuery $mode"
    tkwait visibility .queryInfo
    grab set .queryInfo
}

proc setInputFromQuery {mode} {
    variable ftpInfos
    variable ftpVars
    variable options
    
    set entryString [.queryInfo.entry.entry get]
    if {$mode == "pass"} {
        set ftpInfos(password) $entryString
    } else {
        set ftpInfos(userName) $entryString
	if {$ftpInfos(userName) == "anonymous" && $options(email) != 0} {
	    set ftpInfos(password) $options(email)
	}
    }
    grab release .queryInfo
    catch {destroy .queryInfo}
    set ftpVars(jobDone) 1
}
    
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
#
#                    M A I N
#
#
#-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
#*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*- 

#------------------------------------
#  Init of the main window
#------------------------------------
wm title . "tkFTP: Not Connected"
wm iconname . "tkFTP: Not Connected"
wm iconbitmap . $iconPixmap
wm resizable . 0 0

set filesName(0) foo
set currentLocalDir [pwd]

global tkstepOptimized dirs filesName hoverColor
set ftpVars(connected) 0
guiInit
readUserOptions
loadLocalDir
